define([
  'app',
],function (app) {
  app
    .config(['$stateProvider', '$urlRouterProvider','$ionicConfigProvider','$sceDelegateProvider','$provide',function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$sceDelegateProvider,$provide) {

      //$sceDelegateProvider.resourceUrlWhitelist([
      //  // Allow same origin resource loads.
      //  'self',
      //  // Allow loading from our assets domain.  Notice the difference between * and **.
      $sceDelegateProvider.resourceUrlWhitelist([
        // Allow same origin resource loads.
        'self',
        // Allow loading from our assets domain.  Notice the difference between * and **.
        'http://c.damaiplus.com/yungou/apps/api/**']);

      if(!isDebug){
        $provide.decorator("$exceptionHandler",function($delegate){
          return function(exception,cause){
            $delegate(exception, cause);
            ssjjLog.log('AngularJS error:');
            ssjjLog.error({
              msg: exception.message,
              stack: exception.stack
            });
            ga(
              'send',
              'event',
              'AngularJS error',
              exception.message,
              exception.stack,
              0,
              true
            );
          }
        });
      }

      //$urlRouterProvider.otherwise('/tab/mainpage');
      $urlRouterProvider.otherwise('/boostrap/');


      $stateProvider
        .state('boostrap',{
          url: '/boostrap/:invite_code',
          controllerUrl:'html/app_boostrap/controller_app_boostrap',
          controller: 'AppBoostrapController',
          templateUrl: 'webApp/html/app_boostrap/app_boostrap.html',
        })

        // setup an abstract state for the tabs directive
        .state('tab', {
          url: '/tab',
          abstract: true,
          controllerUrl:'html/main_page/js/controller_main_page',
          templateUrl: 'webApp/html/tabs/tabs.html'
        })

        .state('tab.mainpage', {
          url: '/mainpage',
          views: {
            'tab-mainpage': {
              templateUrl: function() { return 'webApp/html/main_page/main_page.html'},
              controllerUrl:'html/main_page/js/controller_main_page',
              controller: 'MainPageController',
              dependencies: []
            }
          },
          onEnter: function() {
            writeTitle('首页');
          }
        })

        //晒单
          .state('tab.shareOrder', {
            url: '/shareOrder',
            views: {
              'tab-shareOrder': {
                templateUrl: function() {return 'webApp/html/share_order/share_order.html'},
                controller: 'ShareOrderCtrl',
                controllerUrl: 'html/share_order/js/controller_share_order',
                dependencies: [
                  'components/view-image-list/view-image-list',
                ]
              }
            },
            onEnter: function() {
              writeTitle('晒单');
            }
          })

          .state('shareOrder', {
            url: '/shareOrder/:uid/:goodsId/:pageTitle',
            cache:false,
                templateUrl: function() {return 'webApp/html/share_order/share_order.html'},
                controller: 'ShareOrderCtrl',
                controllerUrl: 'html/share_order/js/controller_share_order',
                dependencies: [
                  'components/view-image-list/view-image-list',
                ],
                params: {
                  'uid' : null,
                  'goodsId' : null,
                  'pageTitle': null
                }
          })

        //支付
        .state('pay',{
          cache:false,
          url: '/payInfo',
          templateUrl: function() { return 'webApp/html/pay/pay.html'},
          controller: 'PayController',
          controllerUrl: 'html/pay/js/controller_pay',
          onEnter: function() {
            writeTitle('确认订单');
          }
        })

        .state('payTransfer',{
          cache:false,
          url: '/pay',
          templateUrl: function() { return 'webApp/html/pay/pay_transfer_page.html'},
          controller: 'PayTransferController',
          controllerUrl: 'html/pay/js/controller_pay_transfer',
        })

        //支付结果
        .state('payResult',{
          cache:false,
          url: '/payResult/:oderNum',
          templateUrl: function() {return 'webApp/html/pay/pay_result.html'},
          controller: 'PayResultController',
          controllerUrl: 'html/pay/js/controller_pay_result',
          onEnter: function() {
            writeTitle('支付结果');
          },
          params: {
            oderNum: null,
          }
        })

          .state('payResult2',{
            cache:false,
            url: '/payResult2/:oderNum',
            templateUrl: function() {return 'webApp/html/pay/pay_result2.html'},
            controller: 'PayResult2Controller',
            controllerUrl: 'html/pay/js/controller_pay_result2',
            onEnter: function() {
              writeTitle('支付结果');
            },
            params: {
              oderNum: null,
            }
          })

          //充值
          .state('chongzhi',{
              url: '/chongzhi',
              templateUrl: function() {return 'webApp/html/pay/chongzhi.html'},
              controller: 'rechargeCtrl',
              controllerUrl: 'html/pay/js/controller_recharge'
          })

        .state('tab.trolley', {
          cache:false,
          url: '/trolley',
          views: {
            'tab-trolley': {
              templateUrl: function() {return 'webApp/html/trolley/trolley.html'},
              controller: 'TrolleyCtrl',
              controllerUrl:'html/trolley/trolley_controller',
              dependencies: ['components/view-trolley/view_trolley_list']
            }
          },
          onEnter: function() {
            writeTitle('购物车');
          }

        })
        //购物车单独界面
          .state('trolley', {
          cache:false,
               url: '/trolley',
              templateUrl: function() {return 'webApp/html/trolley/trolley2.html'},
              controller: 'TrolleyCtrl',
              controllerUrl:'html/trolley/trolley_controller',
              dependencies: ['components/view-trolley/view_trolley_list'],
          onEnter: function() {
            writeTitle('购物车');
          }

        })
          .state('direct-trolley', {
              cache:false,
              url: '/directTrolley/:goodsId',
              templateUrl: function() {return 'webApp/html/trolley/direct_trolley.html'},
              controller: 'DirectTrolleyCtrl',
              controllerUrl:'html/trolley/direct_trolley_controller',
              //dependencies: ['components/view-trolley/view_trolley_list'],
              onEnter: function() {
                  writeTitle('确认订单');
              },
              params: {
                  goodsId: null
              }

          })

        //最新揭晓页面
        .state('tab.publish', {
          url: '/publish',
          views: {
            'tab-publish': {
              //templateUrl: 'webApp/html/publish/publish.html'},
              templateUrl: function () {return 'webApp/html/publish/publish.html'},
              controller: 'PublishCtrl',
              controllerUrl: 'html/publish/publish_controller'
            }
          },
          onEnter: function() {
            writeTitle('最新揭晓');
          }
        })

        //发现页面
        .state('tab.discovery', {
          url: '/discovery',
          views: {
            'tab-discovery': {
              templateUrl: function () {return 'webApp/html/discovery/discovery.html'},
              controller: 'discoveryCtrl',
              controllerUrl: 'html/discovery/discovery_controller'
            }
          },
          onEnter: function() {
            writeTitle('发现');
          }
        })

          .state('direct-fullIntroduce', {
              url: '/direct/fullIntroduce/:goodsId/',
              templateUrl: function() {return 'webApp/html/detail/full_introduce.html'},
              controller: 'DirectGoodsDetailFullIntroduceController',
              controllerUrl: 'html/detail/controller/direct_full_introduce',
              params: {
                  goodsId: null
              }
          })
          .state('direct-success', {
            url: '/direct/success/:orderNum/',
            templateUrl: function() {return 'webApp/html/pay/direct_success.html'},
            controller: 'DirectSuccess',
            controllerUrl: 'html/pay/js/controller_direct_success',
            params: {
              orderNum: null
            }
          })
          .state('direct-goodsDetail', {
            url: '/direct/:id',
            cache: false,
            templateUrl: function() {return 'webApp/html/detail/direct_goods_detail.html'},
            controller: 'DirectGoodsDetailCtrl',
            controllerUrl: 'html/detail/controller/direct_goods_detail',
            params: {
              id: null,
            }
          })
          .state('direct-shareOrder', {
              url: '/direct/shareOrder/:goodsId',
              templateUrl: function () {return 'webApp/html/detail/direct_share_order.html'},
              controller: 'DirectShareOrderCtrl',
              controllerUrl: 'html/detail/controller/direct_share_order',
              params: {
                  goodsId: null
              }
          })
        //活动详情页面
        .state('activity-goodsDetail', {
          url: '/activity/:activityId',
          cache: false,
          templateUrl: function() {return 'webApp/html/detail/goods_detail.html'},
          controller: 'GoodsDetailCtrl',
          controllerUrl: 'html/detail/controller/goods_detail',
          params: {
            activityId: null,
          }
        }).state('activity-fullIntroduce', {
          url: '/activity/:activityId/fullIntroduce/:goodsId',
          templateUrl: function() {return 'webApp/html/detail/full_introduce.html'},
          controller: 'GoodsDetailFullIntroduceController',
          controllerUrl: 'html/detail/controller/full_introduce',
          params: {
            activity: null,
            activityId: null,
            goodsId: null
          }
        }).state('activity-lastPublishes', {
          url: '/activity/:activityId/lastPublishes/:goodsId',
          templateUrl: function() {return 'webApp/html/detail/last_publishes.html'},
          controller: 'LastPublishesCtrl',
          controllerUrl: 'html/detail/controller/last_publishes',
          params: {
            activity: null,
            activityId: null,
            goodsId: null
          }
        }).state('activity-joinRecords', {
          url: '/activity/:activityId/joinRecords',
          templateUrl: function() {return 'webApp/html/detail/join_record.html'},
          controller: 'joinRecordCtrl',
          controllerUrl: 'html/detail/controller/join_record',
          params: {
            activity: null,
            activityId: null,
            goodsId: null
          }
        }).state('activity-shareOrder', {
          url: '/activity/:activityId/shareOrder/:goodsId',
          templateUrl: function () {return 'webApp/html/detail/share_order.html'},
          controller: 'shareOrderCtrl',
          controllerUrl: 'html/detail/controller/share_order',
          params: {
            activity: null,
            activityId: null,
            goodsId: null
          }
        }).state('activityRule', {
            cache:false,
            url: '/activityRule',
            templateUrl: function() {return 'webApp/html/detail/activity_rule.html'},
            controller: 'activityCtrl',
            controllerUrl: 'html/detail/controller/controller_activity_rule',
            onEnter: function() {
              writeTitle('红包规则');
            }
        })

        //分类
        .state('classification',{
          cache : true,
          url: '/classification',
          templateUrl: function() {return 'webApp/html/classification/classification_page.html'},
          controller: 'ClassificationController',
          controllerUrl: 'html/classification/controller_classification',
          onEnter: function() {
            writeTitle('分类浏览');
          }
        }).state('shopClassificationList',{
          url: '/shopClassificationList/:type/:title',
          templateUrl: function() {return 'webApp/html/classification/shop_classification_list_page.html'},
          controller: 'shopClassificationListController',
          controllerUrl: 'html/classification/controller_shop_classification_list',
        })
        .state('limitArea',{
          url: '/limitArea',
          templateUrl: function() {return 'webApp/html/classification/limit_area.html'},
          controller: 'limitAreaController',
          controllerUrl: 'html/classification/limit_area',
        })

        .state('tenYuan',{
          url: '/tenYuan/:type',
          templateUrl: function() {return 'webApp/html/classification/tenYuan.html'},
          controller: 'tenYuanController',
          controllerUrl: 'html/classification/tenYuan',
        })

          .state('directArea',{
            url: '/directArea',
            templateUrl: function() {return 'webApp/html/classification/direct_area.html'},
            controller: 'directAreaController',
            controllerUrl: 'html/classification/direct_area',
          })

        //搜索
        .state('search',{
          cache:true,
          url: '/search',
          templateUrl: function() {return 'webApp/html/search/search_page.html'},
          controller: 'SearchController',
          controllerUrl: 'html/search/controller_search',
        })
        //搜索结果
        .state('searchResult',{
          cache:false,
          url: '/searchResult/:keyword',
          templateUrl: function() {return 'webApp/html/search/search_result_page.html'},
          controller: 'SearchResultController',
          controllerUrl: 'html/search/controller_search_result',
        })

        //login view begin
        .state('login', {
          cache: true,
          url:'/login',
          templateUrl: function() {return 'webApp/html/login_register/login.html'},
          controller: 'LoginCtrl',
          controllerUrl: 'html/login_register/js/controller_login',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          params : {
            state : null
          },
          onEnter: function() {
            writeTitle('登录');
          }
        })

        .state('loginTransferPage',{
          cache: false,
          url: '/loginTransferPage/:sessid',
          templateUrl: function() {return 'webApp/html/login_register/login_transfer_page.html'},
          controller: 'LoginTransferPageCtrl',
          dependencies: ['html/login_register/js/controller_login_transfer_page'],
          params : {
            'sessid' : null
          }
        })

        .state('registerFirst',{
          cache : false,
          url: '/registerFirst',
          templateUrl: function() {return 'webApp/html/login_register/register_first.html'},
          controller: 'RegisterFirstCtrl',
          controllerUrl: 'html/login_register/js/controller_register_first',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          onEnter: function() {
            writeTitle('注册');
          }
        })

        .state('registerSecond',{
          cache: false,
          url: '/registerSecond',
          templateUrl: function() {return 'webApp/html/login_register/register_second.html'},
          controller: 'registerSecondCtrl',
          controllerUrl: 'html/login_register/js/controller_register_second',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          params: {
            'phoneNumber': null ,
            'password' : null ,
            'mcode' : null,
            'inviteCode' : null
          },
          onEnter: function() {
            writeTitle('注册');
          }
        })


        .state('findPassword',{
          cache: false,
          url: '/findPassword',
          templateUrl: function() {return 'webApp/html/login_register/find_password.html'},
          controller: 'FindPasswordCtrl',
          controllerUrl: 'html/login_register/js/controller_find_password',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          onEnter: function() {
            writeTitle('忘记密码');
          }
        })

        .state('resetPassword',{
          cache: false,
          url: '/resetPassword',
          templateUrl: function() {return 'webApp/html/login_register/reset_password.html'},
          controller: 'ResetPasswordCtrl',
          controllerUrl: 'html/login_register/js/controller_reset_password',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          params: {'saveKey': null},
          onEnter: function() {
            writeTitle('重置密码');
          }
        })

        .state('modifyPassword',{
          cache: false,
          url: '/modifyPassword',
          templateUrl: function() {return 'webApp/html/login_register/modify_password.html'},
          controller: 'ModifyPasswordCtrl',
          controllerUrl: 'html/login_register/js/controller_modify_password',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          onEnter: function() {
            writeTitle('修改密码');
          }
        })

        .state('modifyNick',{
          cache: false,
          url: '/modifyNick',
          templateUrl: function() {return 'webApp/html/login_register/modify_nick.html'},
          controller: 'ModifyNickCtrl',
          controllerUrl: 'html/login_register/js/controller_modify_nick',
          dependencies: [
            'components/view-input/view_input',
            'models/model_user'
          ],
          params : {
            'nick' : null
          },
          onEnter: function() {
            writeTitle('修改昵称');
          }
        })

        //我
        .state('tab.account', {
          cache: true,
          url: '/account',
          views: {
            'tab-account': {
              templateUrl: function() {return 'webApp/html/user/tab_account.html'},
              controller: 'AccountCtrl',
              controllerUrl: 'html/user/js/controller_account',
              dependencies: [
                'models/model_user'
              ]
            }
          },
          onEnter: function() {
            writeTitle('我');
          }
        })

        //消息界面
        .state('myNews',{
          url: '/myNews',
          templateUrl: function() {return 'webApp/html/news/news.html'},
          controller: 'NewsController',
          controllerUrl: 'html/news/js/controller_news',
          cache: false,
          onEnter: function() {
            writeTitle('消息');
          }
        })

        //个人信息
        .state('userDetail', {
          url: '/userDetail',
          templateUrl: function() {return 'webApp/html/user/user_detail.html'},
          controller: 'UserDetailCtrl',
          controllerUrl: 'html/user/js/controller_user_detail',
          dependencies: [
            'models/model_user'
          ],
          onEnter: function() {
            writeTitle('个人信息');
          }

        })

        //常见问题
        .state('question',{
          cache:false,
          url:'/question/:viewName',
          templateUrl: function($stateParams) {
            var view_name = 'question';
            view_name  = angular.isString($stateParams.viewName) ? $stateParams.viewName : view_name;
            return 'webApp/html/user/view_'+view_name+'.html';
          },
          controller: 'UserQuestionController',
          controllerUrl: 'html/user/js/controller_user_question',
          params: {
            'viewName' : null
          },
        })

        .state('setting', {
          cache:false,
          url: '/setting',
          templateUrl: function() {return 'webApp/html/setting/setting.html'},
          controller: 'SettingCtrl',
          controllerUrl: 'html/setting/js/controller_setting',
          dependencies: [],
          onEnter: function() {
            writeTitle('设置');
          }
        })

        //关于我们
        .state('aboutUs',{
          cache:false,
          url: '/aboutUs',
          templateUrl: function() {return 'webApp/html/user/view_about_us.html'},
          onEnter: function() {
            writeTitle('关于我们');
          }
        })




        //地址列表
        .state('addressList', {
          cache:false,
          url: '/addressList',
          templateUrl: function() {return 'webApp/html/address/address_list.html'},
          controller: 'AddressListCtrl',
          controllerUrl: 'html/address/js/controller_address_list',
          dependencies: [],
          onEnter: function() {
            writeTitle('收货地址');
          }
        })

        //选择收货地址
        .state('addressSelect', {
          cache:false,
          url: '/addressSelect/:activity_id/:type',
          templateUrl: function() {return 'webApp/html/address/address_select.html'},
          controller: 'AddressSelectCtrl',
          controllerUrl: 'html/address/js/controller_address_select',
          dependencies: [],
          params : {
            // 'activity_id' : null,
            // 'type':null
          },
          onEnter: function() {
            writeTitle('选择收货地址');
          }
        })

        //增加地址页面
        .state('addressAdd', {
          cache:false,
          url: '/addressAdd',
          templateUrl: function() {return 'webApp/html/address/address_add.html'},
          controller: 'AddressAddCtrl',
          controllerUrl: 'html/address/js/controller_address_add',
          dependencies: ['components/view-area-selector/view_area_selector'],
          onEnter: function() {
            writeTitle('新增收货地址');
          }
        })

        //修改地址页面
        .state('addressUpdate', {
          cache:false,
          url: '/addressUpdate',
          templateUrl: function() {return 'webApp/html/address/address_update.html'},
          controller: 'AddressUpdateCtrl',
          controllerUrl: 'html/address/js/controller_address_update',
          dependencies: ['components/view-area-selector/view_area_selector'],
          params : {
            'address' : null
          },
          onEnter: function() {
            writeTitle('我的收货地址');
          }
        })

        //邀请返利
        .state('invite', {
          cache:false,
          url: '/invite',
          templateUrl: function() {return 'webApp/html/invite/invite.html'},
          controller: 'InviteCtrl',
          controllerUrl: 'html/invite/js/controller_invite',
          dependencies: [],
          onEnter: function() {
            writeTitle('邀请有礼');
          }
        })

        //返利详情
        .state('rebateList', {
          cache:false,
          url: '/rebateList',
          templateUrl: function() {return 'webApp/html/invite/rebate_list.html'},
          controller: 'RebateListCtrl',
          controllerUrl: 'html/invite/js/controller_rebate_list',
          dependencies: [],
          onEnter: function() {
            writeTitle('返利详情');
          }
        })

        //我的红包
        .state('redPacket', {
          cache:false,
          url: '/redPacket',
          templateUrl: function() {return 'webApp/html/red_packet/red_packet.html'},
          controller: 'RedPacketCtrl',
          controllerUrl: 'html/red_packet/js/controller_red_packet',
          dependencies: [],
          onEnter: function() {
            writeTitle('我的红包');
          }
        })

        //红包规则
        .state('redPacketRule', {
            cache:false,
            url: '/redPacketRule',
            templateUrl: function() {return 'webApp/html/red_packet_list/red_packet_rule.html'},
            controller: 'redPacketRuleCtrl',
            controllerUrl: 'html/red_packet_list/js/controller_redPacket_rule',
            onEnter: function() {
              writeTitle('红包规则');
            }
        })


        //我的夺宝记录
        .state('myIndianaRecord', {
          cache:false,
          url: '/myIndianaRecord',
          templateUrl: function() {return 'webApp/html/indiana_record/mypage.html'},
          controller: 'MyPageCtrl',
          controllerUrl: 'html/indiana_record/js/controller_mypage',
          dependencies: [],
          params:{
            uid:null
          },
          onEnter: function() {
            writeTitle('夺宝记录');
          }
        })

        //我的直购记录
          .state('myDirectRecord', {
            cache:false,
            url: '/myDirectRecord',
            templateUrl: function() {return 'webApp/html/direct_record/my.html'},
            controller: 'MyDirectCtrl',
            controllerUrl: 'html/direct_record/js/controller_mydirectpage',
            dependencies: [],
            params:{
              uid:null
            },
            onEnter: function() {
              writeTitle('直购记录');
            }
          })

        //他的夺宝记录
        .state('hispage', {
          url: '/hispage/:uid/:unick',
          cache:false,
          controllerUrl:'html/indiana_record/js/controller_hispage',
          controller: 'hisPageCtrl',
          templateUrl: function() {return 'webApp/html/indiana_record/hispage.html'},
          params:{
            uicon:null
          },
          onEnter: function() {
            writeTitle('TA的夺宝记录');
          }
        })

        //我的中奖纪录
        .state('winningRecord', {
          cache:false,
          url: '/winningRecord',
          templateUrl: function() {return 'webApp/html/winning_record/winning_record.html'},
          controller: 'WinningRecordCtrl',
          controllerUrl: 'html/winning_record/js/controller_winning_record',
          params : {
            'activity_id' : null ,
            'address' : null
          },
          onEnter: function() {
            writeTitle('中奖记录');
          }
        })

        .state('editShareOrder', {
          cache:false,
          url: '/editShareOrder',
          templateUrl: function() {return 'webApp/html/share_order/edit_share_order.html'},
          controller: 'EditShareOrderCtrl',
          controllerUrl: 'html/share_order/js/controller_edit_share_order',
          params : {
            'activity_id' : null ,
            'direct_id' : null ,
            'address' : null
          },
          onEnter: function() {
            writeTitle('编辑晒单');
          }
        })

          //计算规则
          .state('countRule', {
              cache:false,
              url: '/countRule',
              templateUrl: function() {return 'webApp/html/count/count_rule.html'},
              controller: '',
              controllerUrl: '',
              onEnter: function() {
                writeTitle('计算规则');
              }
          })

          //计算详情
          .state('countDetail', {
              cache:false,
              url: '/countDetail/:activityId',
              templateUrl: function() {return 'webApp/html/count/count_detail.html'},
              controller: 'CountDetailCtrl',
              controllerUrl: 'html/count/controller_count_detail',
              params: {
                activityId: null
              },
              onEnter: function() {
                writeTitle('计算详情');
              }
          })

          //我的积分
          .state('myPoint', {
              cache:false,
              url: '/myPoint',
              templateUrl: function() {return 'webApp/html/my_point/my_point.html'},
              controller: 'myPointCtrl',
              controllerUrl: 'html/my_point/js/controller_my_point',

              onEnter: function() {
                writeTitle('我的积分');
              }
          })

          //积分规则
          .state('pointRule', {
              cache:false,
              url: '/pointRule',
              templateUrl: function() {return 'webApp/html/my_point/point_rule.html'},
              controller: 'pointRuleCtrl',
              controllerUrl: 'html/my_point/js/controller_point_rule',
              onEnter: function() {
                writeTitle('积分规则');
              }
          })
          //积分明细
          .state('pointDetails', {
              cache:false,
              url: '/pointDetails',
              templateUrl: function() {return 'webApp/html/point_details/point_details.html'},
              controller: 'pointDetailsCtrl',
              controllerUrl: 'html/point_details/js/controller_point_details',

              onEnter: function() {
                writeTitle('积分明细');
              }
          })
          //邀请好友明细
          .state('inviteDetails', {
              cache:false,
              url: '/inviteDetails',
              templateUrl: function() {return 'webApp/html/invite_details/invite_details.html'},
              controller: 'inviteDetailsCtrl',
              controllerUrl: 'html/invite_details/js/controller_invite_details',

              onEnter: function() {
                writeTitle('邀请好友明细');
              }
          })

          //佣金明细
          .state('commissionDetails', {
              cache:false,
              url: '/commissionDetails',
              templateUrl: function() {return 'webApp/html/commission_details/commission_details.html'},
              controller: 'commissionDetailsCtrl',
              controllerUrl: 'html/commission_details/js/controller_commission_details',

              onEnter: function() {
                writeTitle('佣金明细');
              }
          })

          //邀请好友
          .state('inviteFriends', {
              cache:false,
              url: '/inviteFriends',
              templateUrl: function() {return 'webApp/html/invite_friends/invite_friends.html'},
              controller: 'inviteFriendsCtrl',
              controllerUrl: 'html/invite_friends/js/controller_invite_friends',

              onEnter: function() {
                writeTitle('邀请好友');
              }
          })

          //红包列表
          .state('redPacketList', {
            cache:false,
            url: '/redPacketList',
            templateUrl: function() {return 'webApp/html/red_packet_list/red_packet_list.html'},
            controller: 'redPacketListCtrl',
            controllerUrl: 'html/red_packet_list/js/controller_red_packet_list',
            onEnter: function() {
              writeTitle('红包列表');
            }
          })

          //抢红包
          .state('grabRedPacket', {
            cache:false,
            url: '/grabRedPacket/:activity_id',
            templateUrl: function() {return 'webApp/html/grab_red_packet/grab_red_packet.html'},
            controller: 'grabRedPacketCtrl',
            controllerUrl: 'html/grab_red_packet/js/controller_grab_red_packet',
            onEnter: function() {
              writeTitle('抢红包');
            }
          })

          //红包参与记录
          .state('redPacketJoinRecord', {
            cache:false,
            url: '/redPacketJoinRecord/:activity_id',
            templateUrl: function() {return 'webApp/html/grab_red_packet/redPacketJoinRecord.html'},
            controller: 'redPacketJoinRecordCtrl',
            controllerUrl: 'html/grab_red_packet/js/redPacketJoinRecord',
            onEnter: function() {
              writeTitle('红包参与记录');
            }
          })

          //红包往期揭晓
          .state('redPacketLastPublished', {
            cache:false,
            url: '/redPacketLastPublished/:red_id',
            templateUrl: function() {return 'webApp/html/grab_red_packet/redPacketLastPublished.html'},
            controller: 'redPacketLastPublishedCtrl',
            controllerUrl: 'html/grab_red_packet/js/redPacketLastPublished',
            onEnter: function() {
              writeTitle('红包往期揭晓');
            }
          })

          //我的余额
          .state('myAccount', {
              cache:false,
              url: '/myAccount',
              templateUrl: function() {return 'webApp/html/my_account/my_account.html'},
              controller: 'myAccountCtrl',
              controllerUrl: 'html/my_account/js/controller_my_account',

              onEnter: function() {
                writeTitle('我的余额');
              }
          })
          //余额明细
          .state('myAccountDetails', {
              cache:false,
              url: '/myAccountDetails',
              templateUrl: function() {return 'webApp/html/my_account_details/my_account_details.html'},
              controller: 'myAccountDetailsCtrl',
              controllerUrl: 'html/my_account_details/js/controller_my_account_details',

              onEnter: function() {
                writeTitle('余额明细');
              }
          })

          //评论
          .state('commentDetails', {
              cache:false,
              url: '/commentDetails/:id',
              templateUrl: function() {return 'webApp/html/comment_details/comment_details.html'},
              controller: 'commentDetailsCtrl',
              controllerUrl: 'html/comment_details/js/controller_comment_details',

              onEnter: function() {
                writeTitle('评论');
              }
          })
          //抽奖
          .state('turntable', {
              cache:false,
              url: '/turntable',
              templateUrl: function() {return 'webApp/html/turntable/turntable.html'},
              controller: 'turntableCtrl',
              controllerUrl: 'html/turntable/js/controller_turntable',
              onEnter: function() {
                writeTitle('抽奖');
              }
          })

          //抽奖规则
          .state('turntableRule', {
              cache:false,
              url: '/turntableRule',
              templateUrl: function() {return 'webApp/html/turntable/turntable_rule.html'},
              controller: 'turntableRuleCtrl',
              controllerUrl: 'html/turntable/js/controller_turntable_rule',
              onEnter: function() {
                writeTitle('抽奖规则');
              }
          })
          //引导页
          .state('guide_page', {
              cache:false,
              url: '/guide_page',
              templateUrl: function() {return 'webApp/html/guide_page/guide_page.html'},
              controller: 'guide_pageCtrl',
              controllerUrl: 'html/guide_page/guide_page',

              onEnter: function() {
                writeTitle('引导页');
              }
          })

          //评论
          .state('test', {
              cache:false,
              url: '/test',
              templateUrl: function() {return 'webApp/html/test/test.html'},
              controller: 'testCtrl',
              controllerUrl: 'html/test/js/test',

              onEnter: function() {
                writeTitle('评论');
              }
          })

          //提现记录
          .state('withdrawCashRecord', {
              cache:false,
              url: '/withdraw_cash_record',
              templateUrl: function() {return 'webApp/html/withdraw_cash/withdraw_cash_record.html'},
              controller: 'withdrawCashRecordCtrl',
              controllerUrl: 'html/withdraw_cash/js/controller_withdraw_cash_record',

              onEnter: function() {
                writeTitle('提现申请记录');
              }
          })

          //申请提现
          .state('applyWithdrawCash', {
              cache:false,
              url: '/apply_withdraw_cash',
              templateUrl: function() {return 'webApp/html/withdraw_cash/apply_withdraw_cash.html'},
              controller: 'applyWithdrawCashCtrl',
              controllerUrl: 'html/withdraw_cash/js/controller_apply_withdraw_cash',

              onEnter: function() {
                writeTitle('申请提现');
              }
          })

          //积分兑换余额
          .state('changePoint', {
              cache:false,
              url: '/changePoint',
              templateUrl: function() {return 'webApp/html/changePoint/changePoint.html'},
              controller: 'changePointCtrl',
              controllerUrl: 'html/changePoint/js/controller_changePoint',

              onEnter: function() {
                writeTitle('积分兑换余额');
              }
          })

     	   .state('shareDetails', {
            cache:false,
            url: '/shareDetails/:show_id',
            templateUrl: function() {return 'webApp/html/share_order/shareDetails.html'},
            controller: 'shareDetailsCtrl',
            controllerUrl: 'html/share_order/js/shareDetails',
            dependencies: [
              'components/view-image-list/view-image-list',
            ],
            onEnter: function() {
                writeTitle('晒单详情');
              }
           
          })
          .state('attention', {
            cache:false,
            url: '/attention',
            templateUrl: function() {return 'webApp/html/attention/attention.html'},
            controller: 'attentionCtrl',
            controllerUrl: 'html/attention/attention',
            dependencies: [
              
            ],
            onEnter: function() {
                writeTitle('关注官方微信');
              }
           
          })
          .state('buyDetails', {
            cache:false,
            url: '/buyDetails',
            templateUrl: function() {return 'webApp/html/buyDetails/buyDetails.html'},
            controller: 'buyDetailsCtrl',
            controllerUrl: 'html/buyDetails/buyDetails',
            dependencies: [
              
            ],
            onEnter: function() {
                writeTitle('购买明细');
              }
           
          })

      ;

      // if none of the above states are matched, use this as the fallback
      $ionicConfigProvider.platform.ios.tabs.position('bottom');
      $ionicConfigProvider.platform.android.tabs.position('bottom');
      $ionicConfigProvider.scrolling.jsScrolling(true);

      if(ionic.Platform.ua.toLowerCase().match(/MicroMessenger/i) == "micromessenger") {
          
          $ionicConfigProvider.views.transition('none')
      } 

      $ionicConfigProvider.views.swipeBackEnabled(false);
      $ionicConfigProvider.views.maxCache(5);//优化缓存页数
    }]);
});
