/**
 * Created by luliang on 2015/11/14.
 */
define(
  ['app',
    'html/trolley/trolley_service',
    'components/view-progress/view_progress',
    'lib/ng-lazyload',
    'utils/toastUtil',
    'models/model_activity',
    'html/common/global_service'
  ],function(app){
  'use strict';
  app
    .directive('viewBroad',['$ionicScrollDelegate','$state','trolleyInfo','ActivityModel','ToastUtils',function($ionicScrollDelegate,$state,trolleyInfo,ActivityModel,ToastUtils){
      return {
        restrict:'E',
        scope: {
          compId:'=',
          dpTopBarTitle: '=',
          dpSetTopBar: '=',
          dpIsAutoLoad: '=',
          dpIsShortList:'=',
          dpPageSize:'=',
          dpFilterClass:'=',
          dpFilterTitle:'@',
          dpFilterOrder:'@',
          dpFilterOrderType:'@',
          dpFilterStatus:'@',
          dpFilterType:'@',
          dpToggleDate:'=',
          dpToggleComment:'=',
          dpSplitSize:'=',
          dpFilterOrder2:'=',
          dpFilterOrderType2:'='
        },
        controller: ['$scope','$element','$attrs','$transclude',function($scope,$element,$attrs,
                                                                         $transclude){
          $scope.broadlist = [];

          $scope.requestParams = {
            goods_type_id:$scope.dpFilterClass,
            key_word:$scope.dpFilterTitle || null,
            order_key:$scope.dpFilterOrder || null,
            order_type:$scope.dpFilterOrderType || null,
            status :$scope.dpFilterStatus || null,
            activity_type : $scope.dpFilterType || null,
            from:1,
            count:$scope.dpPageSize || 10,
          };

          $scope.removeTheBroad = function(brodData){
            var k = $scope.broadlist.indexOf(brodData);
            if(k != -1){
              $scope.broadlist.splice(k,1);
            }
          };
          $scope.addTheBroadData = function(broadData){
            $scope.broadlist.push(broadData);
          };
          $scope.addTheBroadList = function(broadList){
            return $scope.broadlist.concat(broadList);
          };
        }],
        compile:function compile(tElement, tAttrs, transclude){
          return{
            pre:function preLink(scope, iElement, iAttrs, controller){

            },
            post:function postLink(scope, iElement, iAttrs, controller){
              var perPageLoadData = 0;
              //scope.style_isCartBtnClick = false;
              var isStartHttp = false;
              scope.disconnected = false;
              scope.isLoadFinished = true;
              scope.isFinish = false;
              scope.resetFresh = resetFresh;
              scope.loadMore = loadMore;
              scope.reloadPrePage = reloadPrePage;
              scope.loadNextPage = loadNextPage;

              function _dpFilterClass(){
                return scope.dpFilterClass || null;
              }

              scope.$watch('dpFilterOrder2',function (newvalue,oldvalue) {
                //if(newvalue)
                scope.requestParams.order_key = newvalue;
              });
              scope.$watch('dpFilterOrderType2',function (newvalue,oldvalue) {
                //if(newvalue)
                scope.requestParams.order_type = newvalue;
              });

              function getRequestParams(){
                scope.requestParams.goods_type_id = _dpFilterClass();
                return scope.requestParams;
              }
              var startLoadEvent = scope.$on('broad.loadMore',function(event,id){
                if(scope.compId == id&&scope.isEnableScrollToLoad()){
                  loadMore();
                }else{
                  scope.$emit('view_broad.request_finished',
                    {id:scope.did,scope:SCOPE_CLASS.LIST,data:{}});
                }
              });
              var startRefreshEvent = scope.$on('broad.refresh',function(event,id){
                if(scope.compId == id){
                  resetFresh();
                }
              });

              iElement.bind('$destroy',function(){
                //dom释放资源,中断请求
                startLoadEvent();
                startLoadEvent = null;
                startRefreshEvent();
                startRefreshEvent = null;
              });

              scope.isEnableScrollToLoad = function(){
                if(typeof scope.dpSplitSize === 'undefined'){
                  return true;
                }else{
                  return (perPageLoadData　<　scope.dpSplitSize);
                }
              };

              function setPageLoadedData(length){
                if(typeof scope.dpSplitSize === 'undefined'){
                  return ;
                }
                perPageLoadData  += length;　
              }

              function reloadPrePage(){
                var params = getRequestParams();
                params.from -= (perPageLoadData + scope.dpSplitSize);
                if(params.from <= 0){
                  params.from = 1;
                }

                scope.requestParams = params;
                scope.broadlist = [];
                perPageLoadData = 0;
                $ionicScrollDelegate.scrollBottom();
                doRefresh();
              }

              function loadNextPage(){
                perPageLoadData = 0;
                scope.broadlist = [];
                $ionicScrollDelegate.scrollTop();
                loadMore();
              }

              function resetFresh(){
                scope.requestParams.from = 1;
                doRefresh();
              }

              function doRefresh(){
                isStartHttp = true;
                //console.info('id:'+scope.compId+'开始刷新');
                var params = getRequestParams();
                ActivityModel.getActivityList(params.goods_type_id,params.key_word,params.order_key,params.order_type,
                  params.from,params.count,params.status,params.activity_type,function(response,data){
                  var code = data.code;
                  if(code == 0){
                    var dataArray = data.data;
                    var length = dataArray.length;
                    scope.broadlist = dataArray;
                    perPageLoadData = length;
                    scope.requestParams.from += length;
                    scope.isFinish = params.count > length;
                    scope.$emit('view_broad.request_success',
                      {id:scope.did,scope:SCOPE_CLASS.LIST,data:{isFinish:scope.isFinish}});
                  }else{
                    ToastUtils.showMsgWithCode(code,data.msg);
                  }
                },function(response,data){
                  ToastUtils.showMsgWithCode(7,'刷新商品列表失败：'+'状态码：'+response.status);
                    scope.disconnected = true;
                },onFinal);
              }

              function loadMore() {
                if(isStartHttp){
                  return ;
                }
                isStartHttp = true;
                scope.isLoadFinished = false;
                //console.info('id:'+scope.compId+'开始加载更多');
                var params = getRequestParams();
                ActivityModel.getActivityList(params.goods_type_id,params.key_word,params.order_key,params.order_type,
                  params.from,params.count,params.status,params.activity_type, function(response,data){
                    var code = data.code;
                    if(code == 0){
                      var dataArray = data.data;
                      var length = dataArray.length;
                      if(length == 0){
                        scope.isFinish = true;
                        scope.$emit('view_broad.request_success',
                          {id:scope.did,scope:SCOPE_CLASS.LIST,data:{isFinish:scope.isFinish}});
                        return ;
                      }
                      setPageLoadedData(length);
                      scope.broadlist = scope.addTheBroadList(dataArray);
                      scope.isFinish = params.count > length;
                      scope.requestParams.from += length;
                      scope.$emit('view_broad.request_success',
                        {id:scope.did,scope:SCOPE_CLASS.LIST,data:{isFinish:scope.isFinish}});
                    }else{
                      ToastUtils.showMsgWithCode(code,"加载文章列表失败："+data.msg);
                    }
                  },function(response,data){
                    ToastUtils.showMsgWithCode(7,'加载更多文章列表失败：'+'状态码'+response.status);
                    scope.disconnected = true;
                  }, onFinal);
              }

              function onFinal(result){
                //console.info(window.JSON.stringify(result));
                scope.isLoadFinished = true;
                isStartHttp = false;
                scope.$emit('view_broad.request_finished',
                  {id:scope.did,scope:SCOPE_CLASS.LIST,data:{}});
              }

              scope.showTheListAll = function(){
                $state.go('shopClassificationList',{type:scope.dpFilterClass || '全部',title:'红包夺车'});
              };

              function addToCart(broad){
                var shopItem = broad;
                shopItem.join_number = 1;
                trolleyInfo.addGoodsItem(shopItem);
              };

              scope.addToCart = addToCart;

              scope.addListToCart = function(list){
                var key;
                for(key in list){
                  addToCart(list[key]);
                }
                ToastUtils.showSuccess('全部添加成功');
              };

              scope.getPercentageProgress = function(remain_num,need_num){
                
		  var progress = (need_num - remain_num) * 100 / need_num;
	          if(progress > 0 && progress < 1) progress = 1;
	          return Math.floor(progress);
              };

              scope.gotoDetail = function(id){
                $state.go('activity-goodsDetail', {activityId:id});
              };

              scope.gotoDirectDetail = function(id){
                $state.go('direct-goodsDetail', {id:id});
              };
              if(scope.dpIsAutoLoad){
                resetFresh();
              }
            }
          }
        },
        templateUrl: function(elem, attr) {
          var path = "webApp/components/view-broad/";
          var fileName = "view_broad_" + attr.type + ".html";
          return path+fileName;
        }
      };
    }]);


});
