/**
 * Created by suiman on 16/1/22.
 */

//弹窗类型
var POP_TYPE_CART = 0;   //加入购物车
var POP_TYPE_BUY = 1;    //立即夺宝
var POP_TYPE_ADD = 2;    //追加夺宝
var POP_TYPE_OTHERS = 3; //其他

define(['app'], function (app) {
  app.directive('viewBuyPop', viewBuyPop);

  viewBuyPop.$inject = ['trolleyInfo', '$state', 'ToastUtils'];

  function viewBuyPop(trolleyInfo, $state, ToastUtils) {
    return {
      restrict: 'E',
      templateUrl: 'webApp/components/view-buy-pop/view_buy_pop.html',
      scope: {
        headTitle: '@',
        buttonText: '='
      },
      link: function postLink(scope, elem, attrs) {
        scope.isShowAddPay = false;
        var unit;
        var buttonType;

        scope.$on('view-buy-pop.show', function (event, goodsInfo) {
          scope.showAddPay(goodsInfo);
        });
        scope.$on('view-buy-pop.hide', function (event) {
          scope.closeAddPay();
        });

        /*根据按钮的内容，判断弹窗的类型*/
        function getPopType(text) {
          if (text == '加入购物车') {
            return POP_TYPE_CART;
          } else if (text == '立即夺宝') {
            return POP_TYPE_BUY;
          } else if (text == '追加夺宝') {
            return POP_TYPE_ADD;
          } else {
            return POP_TYPE_OTHERS;
          }
        }

        scope.getButtonClass = function () {
          buttonType = getPopType(scope.buttonText);
          if (buttonType == POP_TYPE_CART) {
            return 'dp-button--yellow'
          } else {
            return 'dp-button--red'
          }
        }

        //追加夺宝
        scope.addPay = {
          activity_id: '',
          activity_type: '',
          need_num: '',
          remain_num: '',
          goods_img: '',
          goods_title: '',
          isSelected: false,
          join_number: '',
        };

        /**
         * 显示追加页面
         * @param goodsInfo
         */
        scope.showAddPay = function (goodsInfo) {
          scope.isShowAddPay = true;

          scope.addPay.activity_id = goodsInfo.activity_id;
          scope.addPay.activity_type = goodsInfo.activity_type;
          scope.addPay.need_num = goodsInfo.need_num;
          scope.addPay.remain_num = goodsInfo.remain_num;
          if(angular.isArray(goodsInfo.goods_img) && goodsInfo.goods_img.length>0) {
            scope.addPay.goods_img = goodsInfo.goods_img[0];
          } else {
            scope.addPay.goods_img = goodsInfo.goods_img;
          }
          scope.addPay.goods_title = goodsInfo.goods_title;
          if (scope.addPay.activity_type == 1) {//非限购专区
            scope.addPay.join_number = 1;
            unit = 1;
          } else if (scope.addPay.activity_type == 2) { //十元
            scope.addPay.join_number = 10;
            unit = 10;
          } else if (scope.addPay.activity_type == 7) { //百元
            scope.addPay.join_number = 100;
            unit = 100;
          }  else if(scope.addPay.activity_type == 3) { //限购专区
            scope.addPay.join_number = 1;
            unit = 1;
          }
        };

        /**
         * 关闭追加页面
         */
        scope.closeAddPay = function () {
          scope.isShowAddPay = false;
        };


        /**
         * 追加夺宝并跳转到购物车页面
         */
        scope.startToPay = function () {
          scope.addPay.join_number = validJoinNum(scope.addPay.join_number);
          if (scope.addPay.activity_type == 2) {
            scope.addPay.join_number = scope.addPay.join_number / 10;
          } else if(scope.addPay.activity_type == 7) {
            scope.addPay.join_number = scope.addPay.join_number / 100;
          }
          var goodsItem = angular.merge({},scope.addPay);
          trolleyInfo.addGoodsItem(goodsItem);
          if (buttonType == POP_TYPE_BUY) {
            $state.go('trolley');
          } else {
            scope.closeAddPay();
            ToastUtils.showSuccess('已加入购物车中');
          }
        };


        /**
         * 追加页面-
         */
        scope.decrease = function () {
          scope.addPay.join_number = scope.addPay.join_number - scope.addPay.join_number % unit;
          scope.addPay.join_number = scope.addPay.join_number - unit;
          if (scope.addPay.join_number <= 0) {
            scope.addPay.join_number = unit;
          }
        };

        /**
         * 追加页面+
         */
        scope.increase = function () {
          scope.addPay.join_number = scope.addPay.join_number - scope.addPay.join_number % unit;
          scope.addPay.join_number = scope.addPay.join_number + unit;
          if (scope.addPay.join_number >= scope.addPay.remain_num) {
            scope.addPay.join_number = scope.addPay.remain_num;

          }

          if(scope.addPay.activity_type == 3 && scope.addPay.join_number > 10) scope.addPay.join_number = 10;

        };

        scope.editJoinNumber = function (addPay) {
          var joinNumber = '' + addPay.join_number;
          if (joinNumber == '') {
            scope.addPay.join_number = unit;
            return;
          }
          var remainNumber = scope.addPay.remain_num;
          if(addPay.activity_type==3 && addPay.remain_num > 10) {
                remainNumber = 10;
          }
          var match = joinNumber.match(/^[1-9]\d*/);
          if (match == null) {
            joinNumber = unit;
          } else {
            joinNumber = parseInt(match[0]);
            joinNumber = joinNumber > remainNumber ? remainNumber : joinNumber;
            joinNumber = joinNumber <= 0 ? unit : joinNumber;
          }
          joinNumber = joinNumber - joinNumber % unit;
          joinNumber = joinNumber <= 0 ? unit : joinNumber;
          scope.addPay.join_number = joinNumber;
        };

        function validJoinNum(num) {
          if (num == '' || num < unit) {
            return unit;
          } else {
            return num;
          }
        }


      }
    }
  }
})




