define(
  [
    'app',
    'models/model_goods',
    'html/common/service_user_info',
    'utils/toastUtil'
  ],
  function (app) {
    app.controller('buyDetailsCtrl', joinRecordCtrl);

    joinRecordCtrl.$inject = ['$stateParams', '$scope', '$state', 'GoodsModel','userInfo','ToastUtils'];
    function joinRecordCtrl($stateParams, $scope, $state, GoodsModel,userInfo,ToastUtils) {

      
      $scope.gotoHisPage = function (joinRecordItem) {
        var uicon = joinRecordItem.icon;
        var unick = joinRecordItem.nick;
        var uid = joinRecordItem.uid;
        if(userInfo.getUserInfo().uid==uid){
          $state.go('myIndianaRecord');
        }else{
          $state.go('hispage', {uicon: uicon, unick: unick,uid:uid});
        }
      }
      $scope.num_id = null;
      getBuyDetails(true)

      function getBuyDetails(isRefresh){
        $scope.isLoadFinished = false;
        GoodsModel.buyDetails($scope.num_id,function(response){
          //onSuccess
          var code = response.data.code ;
          var msg = response.data.msg ;
          switch (code){
            case 0 :
              var dataList = response.data.data ;
              if(isRefresh){
                $scope.list = [] ;
              }
              if(dataList.length >= 10){
                $scope.hasMoreData = true ;
                $scope.num_id = msg;
              }else{
                $scope.hasMoreData = false ;
              }
              $scope.list = $scope.list.concat(dataList);
              break;

            default :
              ToastUtils.showError(msg);
              break ;
          }
        },function(response){
         
            ToastUtils.showError('请检查网络状态，状态码：' + response.status);
          
        },function(){
          //onFinal
          $scope.isLoadFinished = true ;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
      }


      $scope.doRefresh = function(){
        $scope.num_id = null;
        $scope.hasMoreData = true ;
        getBuyDetails(true);
      };

      /**
       * 加载更多
       */
      $scope.doLoadMore = function(){
        if($scope.isLoadFinished){
          getBuyDetails(false);
        }

      };


    }
  }
)
