define([
    'app',
    'models/model_user',
    'utils/toastUtil',
    'html/common/storage',
    'html/common/global_service'
], function(app) {

    app.controller(
        'changePointCtrl', ['$scope', '$ionicHistory', '$location', '$state', '$stateParams', '$timeout', 'userModel', 'ToastUtils', '$state', 'Storage','Global','$ionicPopup',
            function($scope, $ionicHistory, $location, $state, $stateParams, $timeout, userModel, ToastUtils, $state, Storage,Global,$ionicPopup) {
                var isSubmiting = false;
                $scope.$on('$ionicView.beforeEnter', function(ev, data) {
                    //获取用户信息
                    sessId = Storage.get("sessId");
                    getMyPoint()
                });
                function getMyPoint() {
                  userModel.getMyPoint(function(xhr, re) {
                      if (re.code == 0) {
                          var pointData = re.data || {point:0,total:0,use:0};
                          Storage.set('myPointData_' + sessId, pointData);
                          $scope.hasPoint = Number(pointData.point);
                      } else {
                          ToastUtils.showError(re.msg);
                      }
                  }, function(xhr, re) {
                      ToastUtils.showError(re.msg);
                  })
                }
                $scope.inputData = {
                    point: ''
                };
                $scope.tipsMsg = '';
                $scope.canGetMoney = 0;
                $scope.inviteMoney = sessionStorage.getItem('inviteMoney');

                function validate() {
                    var msg = "false";
                    var point = Number($scope.inputData.point);
                    if (point === '' || point == 0) {
                        msg = "积分不能为空";
                    } else if (point > $scope.hasPoint) {
                        msg = "兑换不能大于当前积分数";
                    } else if (point % 100 != 0) {
                        msg = "每次兑换的积分只能为100的倍数";
                    } else {
                        msg = "true";
                    }

                    return msg;
                }

                $scope.$watch('inputData.point',function(newValue,oldValue) {
                    var point = Number(newValue) || 0;
                    $scope.canGetMoney = (point / 100).toFixed(2);
                })

                $scope.submit = function() {
                    if (isSubmiting) return;
                    var validateMsg = validate();
                    $scope.tipsMsg = '';
                    if (validateMsg !== 'true') {
                        ToastUtils.showTips(validateMsg);
                        return;
                    }
                    isSubmiting = true;
                    var postData = {
                        point: $scope.inputData.point
                    };
                    userModel.changePoint(postData, function(xhr, re) {
                        var code = re.code;
                        if (code == 0) {
                           
                            ToastUtils.showSuccess('兑换成功！请在余额及明细中查询所得', 2000);
                             $scope.goBack();
                        } else {
                            ToastUtils.showMsgWithCode(code, re.msg);
                        }
                    }, function(response, data) {
                        ToastUtils.showMsgWithCode(7, '积分兑换失败：' + '状态码：' + response.status);
                    }, function() {
                        isSubmiting = false;
                    });
                };
 
                $scope.goBack = function() {

                    if (Global.isInweixinBrowser()) {
                        history.back();
                    } else {
                        $ionicHistory.goBack();
                    }
                };

            }
        ])

});
