/**
 * Created by luliang on 2016/1/7.
 */
define(
  [
    'app',
    'components/view-broad/view_broad',
    'html/classification/service_classification_list',
    'utils/toastUtil'
  ],
  function(app){
    'use strict';
    app
      .controller('directAreaController',['$scope','$stateParams','$timeout','ToastUtils','ClassificationService', function($scope,$stateParams,$timeout,ToastUtils,ClassificationService){
        function initial(){
          $scope.activityType = 5;
            $scope.goods_type_id = null;
            $scope.oderKey = "weight";
          $scope.oderType = "desc";
            $scope.showTitle = '全部分类';
            $scope.sortTitle = '人气';
            writeTitle('直购专区');
        }

        function getCategoryList(){
            ClassificationService.getClasses(function(categoryList){
                $scope.categoryList = [{'name':'全部分类','goods_type_id':0,'img':''}];
                for(var j=0;j<categoryList.length;j++) {
                    $scope.categoryList.push(categoryList[j]);
                }
                var length = $scope.categoryList.length%3;
                if(length!=0){
                    for(var i=0;i<3-length;i++){
                        $scope.categoryList.push({'name':'','goods_type_id':false,'img':''});
                    }
                }
                console.log($scope.categoryList);
            },function(reason){
                console.error(reason);
            });
        }



        //=================注册事件===================
        $scope.$on('view_broad.request_finished',function(event,data){
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          $scope.isLoadFinished = true;
          stopPropagation(event,data.scope);
        });
        $scope.$on('view_broad.request_success',function(event,data){
          $scope.isMoreData = !data.data.isFinish;
          //console.info("$scope.isMoreData："+$scope.isMoreData);
          //ToastUtils.showSuccess('刷新成功');
          stopPropagation(event,data.scope);
        });

          $scope.$on('$ionicView.beforeEnter', function(ev, data) {
              getCategoryList();
              $scope.sort = false;
              $scope.show = false;
          });

        function stopPropagation(event,scope){
          if(scope >= SCOPE_CLASS.PAGE){
            event.stopPropagation();
          }
        }
        //
        $scope.isMoreData = false;
        $scope.isLoadFinished = true;
        //


        $scope.loadMore = function(id){
          $scope.isLoadFinished = false;
          $scope.$broadcast('broad.loadMore',id);
        };

        $scope.show_type = function(){
            if($scope.show) {
                $scope.show = false;
            } else {
                $scope.sort = false;
                $scope.show = true;
            }
        };

          $scope.show_sort = function(){
              if($scope.sort) {
                  $scope.sort = false;
              } else {
                  $scope.show = false;
                  $scope.sort = true;
              }
          };

          $scope.fetchData = function(title,goods_type_id,order_key,order_type) {
              if(goods_type_id===false) return;
              //hide
              $scope.show = false;
              $scope.sort = false;

              if(goods_type_id>=0) {
                  $scope.goods_type_id = goods_type_id;
                  $scope.showTitle = title;
              }else{
                  $scope.sortTitle = title;
              }
              if(order_key){
                  $scope.oderKey = order_key;
                  $scope.oderType = order_type;
              }
              $timeout(function(){
                  $scope.$broadcast('broad.refresh','5-2-001');
              },0);
          }



        initial();
      }]);
  });
