/**
 * Created by luliang on 2016/1/6.
 */
define(
  [
    'app',
    'angularSanitize',
    'filters/html_parse_filter',
    'models/model_goods',
    'utils/toastUtil',
    'components/view-buy-footer/view_buy_footer'
  ],
  function (app) {
    app.controller('DirectGoodsDetailFullIntroduceController', ['$scope', '$sanitize', '$stateParams', 'GoodsModel', 'ToastUtils',
      function ($scope, $sanitize, $stateParams, GoodsModel, ToastUtils) {
        $scope.getGoodsDetail = getGoodsDetail;
        $scope.content = '';
        $scope.goodsId = parseInt($stateParams.goodsId);

        (function initial() {
          getGoodsDetail();
        })();

        function getGoodsDetail() {
          GoodsModel.getGoodsImgDetail($stateParams.goodsId, function onSuccess(response, data) {
            var code = data.code;
            if (0 == code) {
              $scope.content = data.data.html;
              $scope.hasLoad = true;
            } else {
              ToastUtils.showError('加载失败：' + data.msg);
            }
          }, function onFailed(response, data) {
            ToastUtils.showError('网络异常：' + '状态码：' + response.statusText);
            $scope.disconnected = true;
          });
        }

        $scope.isShowDisconnect = function () {
          return ($scope.content.length <= 0) && $scope.disconnected;
        };

        $scope.isShowEmpty = function () {
          return ($scope.content.length <= 0) && $scope.hasLoad;
        };

      }]);
  });
