/**
 * Created by songmars on 15/12/29.
 */

define(
  [
    'app',
    'components/view-progress/view_progress',
    'components/view-countdown/view_countdown',
    'components/view-buy-footer/view_buy_footer',
    'components/view-buy-number-pop/view_buy_number_pop',
    'models/model_goods',
    'models/model_user',
    'html/common/service_user_info',
    'html/common/geturl_service',
    'html/common/global_service',
    'html/thirdParty/thirdparty_wechat_js',
    // 'utils/clipboard',
    'utils/clipboard.min',
  ],
  function(app) {
    "use strict";

    app.controller('DirectGoodsDetailCtrl', DirectGoodsDetailCtrl);
      DirectGoodsDetailCtrl.$inject = ['$scope', '$state', '$stateParams', 'GoodsModel', 'MyUrl', 'ToastUtils', 'userInfo','Global','$ionicHistory','userModel'];
    function DirectGoodsDetailCtrl($scope, $state, $stateParams, GoodsModel, MyUrl, ToastUtils, userInfo,Global,$ionicHistory,userModel) {

      (function init() {
        $scope.isLogin = MyUrl.isLogin();
        $scope.goodsId = parseInt($stateParams.id);
        $scope.refresh = refresh;
        refresh();
      })();
      $scope.$on('$ionicView.enter',function(){
          refresh();
      });

      $scope.gotoMainPage = function() {
        $state.go('tab.mainpage')
      }

      $scope.gotoFullIntroduce = function() {
        $state.go('direct-fullIntroduce', {
          goodsId: $scope.goodsId});
      };


      $scope.gotoOrderList = function() {
        $state.go('direct-shareOrder', {
          goodsId: $scope.goodsId});
      };

      $scope.goToBuy = function(){
          $state.go('direct-trolley', {
              goodsId: $scope.goodsId});
      }

      function refresh() {
        GoodsModel.getGoodsDetail2($scope.goodsId, onSuccess, onFailed, onFinal);
      }

      function onSuccess(response, data) {
        if (data.code == 0) {
          $scope.goods = data.data;
        } else {
          ToastUtils.showError(data.msg);
        }
      }

      function onFailed(response) {
        if (response.status !== 200) {
          ToastUtils.showError('请检查网络');
        }
      }

      function onFinal() {
        $scope.$broadcast('scroll.refreshComplete');
      }

    }
  });


