
define(
  [
    'app',
    'components/view-progress/view_progress',
    'components/view-countdown/view_countdown',
    'components/view-buy-footer/view_buy_footer',
    'components/view-buy-number-pop/view_buy_number_pop',
    'models/model_goods',
    'models/model_user',
    'html/common/service_user_info',
    'html/common/geturl_service',
    'html/common/global_service',
    'html/thirdParty/thirdparty_wechat_js',
    'utils/clipboard.min',
    'html/common/storage'
  ],
  function(app) {
    "use strict";

    app.controller('GoodsDetailCtrl', GoodDetailCtrl);
    GoodDetailCtrl.$inject = ['$scope', '$state', '$stateParams', 'GoodsModel', 'MyUrl', 'ToastUtils', 'userInfo','Global','weChatJs','$ionicHistory','userModel','$ionicPopup','Storage'];
    function GoodDetailCtrl($scope, $state, $stateParams, GoodsModel, MyUrl, ToastUtils, userInfo,Global,weChatJs,$ionicHistory,userModel,$ionicPopup,Storage) {
      var mTitle = appConfig.shareTitle || '对不起，这么晚才告诉你！全部1块钱，随便选！';
      var mImgUrls = baseUrl + appConfig.shareImgUrls || '';
      var mLink = appConfig.shareLink || baseUrl + '#/boostrap/';
      var mContent = appConfig.shareContent || '一元就能买iPhone。最刺激的商城玩法！';
      (function init() {
        $scope.isLogin = MyUrl.isLogin();
        var activityIdCode = $stateParams.activityId;
        if(activityIdCode.indexOf('-') > -1) {
          activityIdCode = activityIdCode.split('-');
          $scope.activityId = parseInt(activityIdCode[0]);
          Global.setInviteCode(activityIdCode[1]);
        } else {
          $scope.activityId = parseInt(activityIdCode);
        }
        
        $scope.refresh = refresh;
        $scope.isBuyNumShow = false;
        $scope.showFullNumbers = showFullNumbers;
        refresh();
      })();
      $scope.$on('$ionicView.enter',function(){
         if(!$ionicHistory.backView() && !Global.isInAPP()) {
            $scope.firstInIsGoodsPage = true;
         } else {
            $scope.firstInIsGoodsPage = false;
         }
      });

      $scope.gotoMainPage = function() {
        $state.go('tab.mainpage')
      }

      $scope.gotoFullIntroduce = function() {
        $state.go('activity-fullIntroduce', {
          activity: $scope.activity,
          activityId: $scope.activityId,
          goodsId: $scope.activity.goods_id});
      };

      $scope.gotoLastPublishes = function() {
        $state.go('activity-lastPublishes', {
          activity: $scope.activity,
          activityId: $scope.activityId,
          goodsId: $scope.activity.goods_id});
      };

      $scope.gotoOrderList = function() {
        $state.go('activity-shareOrder', {
          activity: $scope.activity,
          activityId: $scope.activityId,
          goodsId: $scope.activity.goods_id});
      };

      $scope.gotoJoinRecords = function() {
        $state.go('activity-joinRecords', {
          activity: $scope.activity,
          activityId: $scope.activityId,
          goodsId: $scope.activity.goods_id});
      };

      $scope.gotoCountDetail = function() {
        $state.go('countDetail', {activityId:$scope.activityId});
      };

      $scope.timeoutCallback = function() {
        $state.go('activity-goodsDetail', {activityId: $scope.activityId}, {reload:true});
      };

      $scope.gotoHisPage = function(uid,unick,uicon) {
       
        if(userInfo.getUserInfo().uid === uid){
          $state.go('myIndianaRecord');
        }else{
          $state.go('hispage', {uicon: uicon, unick: unick, uid: uid});
        }
      }

      function refresh() {
        ToastUtils.showLoading('加载中...')
        GoodsModel.getGoodsDetail($scope.activityId, onSuccess, onFailed, onFinal);
      }

      function showFullNumbers() {
        $scope.$broadcast('view_buy_number_pop.show', {compId:'2-2-1', activityId:$scope.activityId, uid:null});
        $scope.isBuyNumShow = true;
      }

      function onSuccess(response, data) {
        if (data.code == 0) {
          $scope.activity = data.data;
          $scope.joinListPage = 1;
          getJoinRecordList();
          

          mImgUrls = $scope.activity.img || baseUrl + appConfig.shareImgUrls;
          var inviteCode = Storage.get('inviteCode');
          if( inviteCode && MyUrl.isLogin()) {
            $scope.mLink = mLink = (baseUrl + '#/activity/' + $scope.activity.activity_id + '-' + inviteCode) || baseUrl + '#/boostrap/' + inviteCode;
          } else {
            $scope.mLink = mLink = (baseUrl + '#/activity/' + $scope.activity.activity_id) || baseUrl + '#/boostrap/';
          }
          
          mTitle = appConfig.shareTitle || '对不起，这么晚才告诉你！全部1块钱，随便选！';
          mContent = $scope.activity.goods_title || '一元就能买iPhone。最刺激的商城玩法！';

          if(Global.isInweixinBrowser()) {
            
            weChatJs.wxShareToTimeline(appConfig.shareTitle, mLink, $scope.activity.img, function() {
                toAddPoint('point');
            }, function(){});
            weChatJs.wxShareToAppMessage(appConfig.shareTitle,$scope.activity.goods_title, mLink, $scope.activity.img, function() {
              toAddPoint('point');
            }, function(){});
          }
        } else {
          ToastUtils.showError(data.msg);
        }
      }

      $scope.getJoinRecordList_1 = getJoinRecordList;
      $scope.isLoadJoin = false;
      function getJoinRecordList() {
        if($scope.isLoadJoin) return;
        $scope.isLoadJoin = true;
        GoodsModel.getJoinRecordList($scope.activityId,($scope.joinListPage - 1)*10 + 1,10, function(xhr,re) {
          if (re.code == 0) {
            if($scope.joinListPage == 1) {
              $scope.joinList = re.data;
            } else {
              $scope.joinList = $scope.joinList.concat(re.data)
            }
            if(re.data.length == 10) {
              $scope.hasNextJoinList = true;
              $scope.joinListPage++;
            } else {
              $scope.hasNextJoinList = false;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }
        }, function() {

        },function() {
          $scope.isLoadJoin = false;
        });
      }


      $scope.shareToWechat = function() {
          if (!MyUrl.isLogin()) {
            $scope.loginPopup = $ionicPopup.confirm({
                title: '<b>温馨提示</b>',
                scope: $scope,
                buttons: [{
                    text: '不登录',
                    onTap: function(e) {
                        showShareType()
                        return false;
                    }
                }, {
                    text: '<b>去登录</b>',
                    type: 'button-assertive',
                    onTap: function(e) {
                        $state.go('login',{'state':STATUS.LOGIN_ABNORMAL});
                        return false;
                    }
                }]
            });
            
          } else {
            showShareType()
          }

          

      };

      function showShareType() {
        if (Global.isInweixinBrowser()) {
            showGuide();
        } else if (Global.isInAPP()) {
            $scope.isShowShare = true;

          } else {
              //uc等浏览器
              clipSuccess();
              toAddPoint('copy');
          }

      };
      //app分享到朋友圈
      $scope.shareToFriendsCircle = function() {
          if (Global.isInAPP()) {
              //app分享
              var data = {
                  "title": mTitle,
                  "content": mContent,
                  "imgUrl": mImgUrls,
                  "targetUrl": mLink
              }
              dmwechat.share('wx_circle',data,function() {
                ToastUtils.showShortNow(STATE_STYLE.GOOD, '分享成功');
                toAddPoint()
              },function(error) {
                ToastUtils.showShortNow(STATE_STYLE.ERROR, error);
              })

          }

      };

      //app分享给好友
      $scope.shareToFriends = function(type) {
          if (Global.isInAPP()) {
              var data = {
                  "title": mTitle,
                  "content": mContent,
                  "imgUrl": mImgUrls,
                  "targetUrl": mLink
              }
              dmwechat.share(type,data,function() {
                ToastUtils.showShortNow(STATE_STYLE.GOOD, '分享成功');
                toAddPoint();
              },function(error) {
                ToastUtils.showShortNow(STATE_STYLE.ERROR, error);
              })

          }

      };

      //复制链接
      $scope.copyLink = function() {

          if (Global.isInAPP()) {

              cordova.plugins.clipboard.copy(mLink);
              ToastUtils.showShortNow(STATE_STYLE.GOOD, '复制成功：' + mLink);
              toAddPoint('copy')
          }


      };

      $scope.hidePop = function() {

          $scope.isShowShare = false;

      };
      $scope.addPoint = true;
      function toAddPoint(type) {
          if (!$scope.addPoint) return;
          if (MyUrl.isLogin()) {
            $scope.addPoint = false;
            userModel.toAddPoint(function(xhr, re) {
                var code = re.code;
                if (code == 0) {
                    if(type != 'copy') {
                        ToastUtils.showShortNow(STATE_STYLE.GOOD, re.msg);
                    }

                } else {
                }
            }, function(response, data) {
                ToastUtils.showMsgWithCode(7, '获取积分失败：' + '状态码：' + response.status);
            }, function() {
                $scope.addPoint = true;
            })
            
          } 
          
      }

      $scope.hideGuide1 = function() {
          hideGuide();
      }

      function showGuide() {
          document.getElementById("guidepop").style.display = 'block';
          $scope.showWxGuide = true;
      }

      function hideGuide() {
          document.getElementById("guidepop").style.display = 'none';
          $scope.showWxGuide = false;
      }

      function clipSuccess() {
          var clipboard = new Clipboard('#goods_share_btn');
          clipboard.on('success', function(e) {
              e.clearSelection();
              ToastUtils.showShortNow(STATE_STYLE.GOOD, '已复制，请粘贴到微信浏览器中打开');
          });


      }

      function onShareSuccess() {
          hideGuide();
          toAddPoint('point')
      }

      function onShareCancel() {
          hideGuide();


      }

      function onSendSuccess() {
          hideGuide();

          ToastUtils.showShortNow(STATE_STYLE.GOOD, '发送给好友成功');
      }

      function onSendCancel() {
          hideGuide();

          ToastUtils.showShortNow(STATE_STYLE.ERROR, '用户已取消发送');

      }

      function onFailed(response) {
        if (response.status !== 200) {
          ToastUtils.showError('请检查网络');
        }
      }

      function onFinal() {
        $scope.$broadcast('scroll.refreshComplete');
        ToastUtils.hideLoading()
      }

    }
  });


