/**
 * Created by Administrator on 2016/1/7.
 */
define([
  'app',
  'models/model_app',
  'html/common/constants',
  'utils/toastUtil',
  'components/view-indiana-record-item/view_indiana_record_item',
  'components/view-list-view/view_list_view',
  'components/view-list-item/view_list_item',
  'components/view-buy-pop/view_buy_pop',
  'components/view-buy-number-pop/view_buy_number_pop',
  'html/common/service_user_info',
  'components/view-image-list/view-image-list',
], function (app) {

  app.controller(
    'hisPageCtrl', ['$scope', '$stateParams', '$ionicHistory', '$state', 'AppModel','userInfo','ToastUtils',

      function ($scope, $stateParams, $ionicHistory, $state, AppModel,userInfo,ToastUtils) {
        $scope.uicon = $stateParams.uicon;
        $scope.unick = $stateParams.unick;
        $scope.uid = $stateParams.uid;
        $scope.isIndianaRecordEmpty = false;
        $scope.isWinRecordEmpty = true;
        $scope.isBuyNumShow = false;


        /**
         * 夺宝记录
         */
        $scope.indianaRequestUrl = AppModel.getRecordListUrl();
        $scope.indianaRequestParams = {
          uid: $scope.uid,
          status: null
        };
        $scope.indianaCallBack = {
          setData: function (data) {
            $scope.indianaList = data;
          },
          setEmpty: function (isEmpty) {
            $scope.isIndianaRecordEmpty = isEmpty;
          }
        };
        $scope.itemCallBack = {
          showBuyPop: function (activity) {
            $scope.$broadcast('view-buy-pop.show', activity);
          },
          showBuyNum: function (activityId, uid) {
            $scope.$broadcast('view_buy_number_pop.show', {compId:'1-4-1', activityId:activityId, uid:$scope.uid});
          },
          showWinOne: function (unick, uicon, uid) {
            ssjjLog.log('uid1'+userInfo.getUserInfo().uid);
            ssjjLog.log('uid2'+uid);
            if(userInfo.getUserInfo().uid==$stateParams.uid||userInfo.getUserInfo().uid==uid){
              $state.go('myIndianaRecord');
            }else{
              $state.go('hispage', {uicon:uicon, unick:unick, uid:uid});
              ssjjLog.log('uicon'+uicon);
              ssjjLog.log('unick'+unick);
              ssjjLog.log('uid'+uid);
            }
          }
        };


        /**
         * 中奖记录
         */
        $scope.winRequestUrl = AppModel.getWinRecordListUrl();
        $scope.winRequestParams = {
          uid: $stateParams.uid,
          from: null
        };
        $scope.gotoDetail = function(id){
          $state.go('activity-goodsDetail', {activityId:id});
        };
        $scope.winCallBack = {
          setData: function (data) {
            $scope.winList = data;
          },
          setEmpty: function (isEmpty) {
            $scope.isWinRecordEmpty = isEmpty;
          }
        };

        $scope.startToMainPage = function() {
          $state.go('tab.mainpage');
        }

        var isDoRefreshing = false ;
        $scope.onTabSelected = function() {
          $scope.hasMoreData = true ;
          $scope.page = 0 ;
          getShareOrderData(true);
        }


        function getShareOrderData(isRefresh){
          $scope.page++;
          AppModel.getShare_list($scope.uid,'time',$scope.page,0,function(response){
            //onSuccess
            var code = response.data.code ;
            var msg = response.data.msg ;
            switch (code){
              case 0 :
                var dataList = response.data.data ;
                if(isRefresh){
                  $scope.orderlist = [] ;
                  isDoRefreshing = false ;
                }
                if(dataList.length>=10){
                  $scope.hasMoreData = true ;
                  // dataList.pop();
                }else{
                  $scope.hasMoreData = false ;
                }
                $scope.orderlist = $scope.orderlist.concat(dataList);
                break;

              default :
                ToastUtils.showError(msg);
                break ;
            }
          },function(response){
            //onFail
           
              ToastUtils.showError('请检查网络状态，状态码：' + response.status);
            
          },function(){
            //onFinal
            $scope.isLoadFinished = true ;
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
            ToastUtils.hideLoading();
          });
        }

        /**
         * 刷新
         */
        $scope.doRefresh = function(){
          $scope.page = 0 ;
          $scope.hasMoreData = true ;
          isDoRefreshing = true ;
          getShareOrderData(isDoRefreshing);
        };

        /**
         * 加载更多
         */
        $scope.doLoadMore = function(){
          if(!isDoRefreshing){
            // indexFrom = $scope.orderlist.length + 1 ;
            getShareOrderData(false);
          }

        };

        $scope.zan = function(order) {
          try {
            if (!MyUrl.isLogin()) {
              event.preventDefault();
              $state.go('login',{'state':STATUS.LOGIN_ABNORMAL});
              ToastUtils.showWarning('请先登录！！');
              return;
            } else {
            }
          } catch (e) {
            console.error('登录判断跳转出错'+ e.name+'：'+ e.message);
          }
          if(order.is_zan) {
            ToastUtils.showSuccess('您已经赞过~');
            return;
          }
          AppModel.zan(order.show_id, function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                order.zans = Number(order.zans) + 1;
                order.is_zan = true;
                ToastUtils.showSuccess('点赞成功');
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '点赞失败：' + '状态码：' + response.status);
          }, null)

        }

      }

    ])

});
