
define([
  'app',
  'html/common/service_user_info',
  'models/model_user',
  'utils/toastUtil',
  'html/common/storage',
  'html/common/global_service'
],function(app){
  app.controller('LoginTransferPageCtrl',
  ['$scope','$state','$stateParams','userModel', 'MyUrl','ToastUtils','$timeout','Global','Storage',
  function($scope, $state, $stateParams,userModel, MyUrl,ToastUtils,$timeout,Global,Storage){

    $scope.inviteCode = {
      code : ''
    };
    
    function initInviteCode(){
      var inviteCode = Global.getInviteCode();
      if(inviteCode==null || inviteCode=='' || angular.isUndefined(inviteCode)){
        $scope.inviteCode.code = '' ;
      }else{
        $scope.inviteCode.code = inviteCode ;
        Global.removeInviteCode();
        bindInviteCode(inviteCode,true)
      }
    }
    MyUrl.setSessid($stateParams.sessid);

    $scope.isShowBindInviteDialog = false ;
    userModel.getLoginUserInfo(function(response){
        var code = response.data.code;
        var msg = response.data.msg ;
        if(code === 0){
          var rltData = response.data.data;
          if(!angular.isUndefined(rltData.rebate_uid) && rltData.rebate_uid==0){
            //显示绑定邀请码对话框
            $scope.isShowBindInviteDialog = true ;
            initInviteCode();
          }else{
            //跳转到首页
            startToPage()
          }
        }else{
          ToastUtils.showError(msg);
        }
    },function(response){
      ToastUtils.showError('请检查网络状态！');
    });



    /**
     * 关闭绑定邀请码对话框
     */
    $scope.closeBindInviteDialog = function(){
      $scope.isShowBindInviteDialog = false ;
      startToPage()
      // bindInviteCode('88888');//邀请码，当用户没有输入时，传88888
    };


    $scope.toBindInviteCode = function(){
        if(!angular.isUndefined($scope.inviteCode.code) && $scope.inviteCode.code!=''){
          bindInviteCode($scope.inviteCode.code);
        }else{
          startToPage()
          // bindInviteCode('88888');//邀请码，当用户没有输入时，传88888
        }
    };


    /**
     * 绑定邀请码
     */
    function bindInviteCode(inviteCode,autoBind){
      userModel.bindInviteCode(inviteCode,function(response){
        var code = response.data.code;
        var msg = response.data.msg ;
        if(code === 0){
          //绑定邀请码成功
          if(!autoBind) ToastUtils.showSuccess('绑定邀请码成功');

          $timeout(function() {//延迟一秒在跳转到主页
            startToPage()
          },1000);

        }else{
          ToastUtils.showError(msg);
        }
      },function(response){
        ToastUtils.showError('请检查网络状态！');
      });
    }

    function startToPage() {
       
            var fromState = Storage.get('fromState')
            var fromParams = Storage.get('fromParams') || {};
            if(fromState) {
                $state.go(fromState,fromParams)
            } else if (status === STATUS.LOGIN_ABNORMAL) {
                $scope.goBack();
            } else {
                $state.go('tab.mainpage');
            } 
        
    }

  }]);


});



