/**
 * Created by Administrator on 2015/11/27.
 */
define([
  'app',
  'models/model_user',
  'utils/toastUtil',
  'html/common/global_service'
],function(app){
  app.controller('RegisterFirstCtrl',
  ['$scope','$state','$ionicHistory','$timeout','userModel','ToastUtils','Global',
  function ($scope, $state,$ionicHistory, $timeout,userModel,ToastUtils,Global) {
    $scope.security = {
      params:baseApiUrl + "?c=user&a=code&t=" + (+new Date()),
      code:''
    }

    $scope.changeGetCodeUrl = function() {
      $scope.security.params = baseApiUrl + "?c=user&a=code&t=" + (+new Date());
    }

    $scope.verifyBtnClickable = true ;
    $scope.agreement = true;

    $scope.registerInfo = {
      phoneNumber : '',
      password : '',
      passwordAgain : '',
      verificationCode : '',
      verificationButtonText : '获取验证码',
      inviteCode : ''
    };
    $scope.registerPageInputHint = {
      phoneNumberHint : '请输入手机号码',
      passwordHint : '请输入6-15位密码',
      passwordAgainHint : '请再次输入密码',
      inviteCodeHint : '邀请码，没有则不填'
    };

    initInviteCode() ;
    function initInviteCode(){
      var inviteCode = Global.getInviteCode();
      if(inviteCode==null || inviteCode=='' || angular.isUndefined(inviteCode)){
        $scope.registerInfo.inviteCode = '' ;
      }else{
        $scope.registerInfo.inviteCode = inviteCode ;
        Global.removeInviteCode();
      }
    }

    $scope.isReadOnly = function(){
      var readOnly = false ;
      if($scope.registerInfo.inviteCode!=''){
        readOnly = true ;
      }
      return readOnly ;
    };

    $scope.sendSmsVerificationCode = function (){
      if(!$scope.verifyBtnClickable){
        return ;
      }
      if(!$scope.security.code) {
        ToastUtils.showWarning('获取手机验证码需要输入图形验证码');
        return;
      }
      if($scope.registerInfo.phoneNumber != ""){
        var number=$scope.registerInfo.phoneNumber;
        userModel.getRegisterSms(number,$scope.security.code,onSuccess,onFail);
      }else{
        ToastUtils.showWarning('请先输入手机号！');
      }
    };


    $scope.registerNext = function(){
      if($scope.registerInfo.verificationCode != ""){
        if($scope.registerInfo.password === $scope.registerInfo.passwordAgain) {
          $state.go('registerSecond', {
            phoneNumber : $scope.registerInfo.phoneNumber ,
            password : $scope.registerInfo.password ,
            mcode : $scope.registerInfo.verificationCode,
            inviteCode : $scope.registerInfo.inviteCode
          });
        }else{
          ToastUtils.showWarning('两次的密码不相同！');
        }
      }else{
        ToastUtils.showWarning('验证码为空！');
      }
    };

    $scope.clickAgreement = function(){
      $scope.agreement = !$scope.agreement;
    };


    $scope.isEnableRegister = function(){
      return ($scope.registerInfo.phoneNumber.length > 0) && ($scope.registerInfo.password.length > 0)
        &&($scope.registerInfo.passwordAgain.length > 0) && ($scope.registerInfo.verificationCode.length > 0)
        &&($scope.agreement);
    };

    function onFail(response){
      ToastUtils.showError('请检查网络状态，状态码：' + response.status);
    }


    function onSuccess(response){
      var code = response.data.code;
      var msg=response.data.msg;
      switch(code){
        case 0:
          ToastUtils.showSuccess(msg);
          $scope.verifyBtnClickable = false ;
          setTimer();
          break;
        default :
          $scope.security.params = baseApiUrl + "?c=user&a=code&t=" + (+new Date());
          $scope.security.code = "";
          ToastUtils.showError(msg);
          break;
      }
    }


    var countdown = 60 ;//60 秒倒计时
    /**
     * 60秒倒计时函数
     */
    function setTimer() {
      if (countdown == 0) {
        $scope.registerInfo.verificationButtonText = "获取验证码";
        countdown = 60;
        $scope.verifyBtnClickable = true ;
      }else{
        $scope.registerInfo.verificationButtonText = "重发(" + countdown + ")";
        countdown -- ;
        $timeout(function() {
          setTimer()
        },1000);
      }
    }

  }]);

});
