
define(
  [
    'app',
    'components/view-slidebox/view_slidebox',
    'components/view-grid/view_grid',
    'components/view-broad/view_broad',
    'utils/toastUtil',
    'models/model_activity',
    'components/view-progress/view_progress',
    'html/trolley/trolley_service',
    'components/view-text-scoller/view_text_scoller',
    'html/common/storage',
    'html/common/global_service',
  ],
  function(app){
    'use strict';
    app
      .controller('MainPageController',['$scope','$state','ToastUtils','ActivityModel','trolleyInfo','Storage','$timeout','$ionicSlideBoxDelegate', 'Global',
        function($scope,$state,ToastUtils,ActivityModel,trolleyInfo,Storage,$timeout,$ionicSlideBoxDelegate, Global){
	    $scope.show_attention = true;
	    if (Global.isInweixinBrowser()) {
	        $scope.inWechatB = true;
	    } else {
	        $scope.inWechatB = false;
	    }
	    $scope.close_attention = function($event) {
	        $event.stopPropagation()
	        $scope.show_attention = false;
	    }
	    $scope.go_attention = function() {
	        $state.go('attention');
	    }
        getBanner();
        //获取广告图
        function getBanner() {
           ActivityModel.getBanner(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.slides = re.data;
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取广告图失败：' + '状态码：' + response.status);
          },null)
        }

        $scope.grids = [
          
          {
            title:'十元专区',
            href : '#/tenYuan/2',
            img : 'img/i222.png'
          },
          {
            title:'百元专区',
            href : '#/tenYuan/7',
            img : 'img/i111.png'
          },
          {
            title:'晒单',
            href : '#/shareOrder/所有/所有/所有晒单',
            img : 'img/i3.png'
          },
          {
            title:'常见问题',
            href : '#/question/question',
            img : 'img/i4.png'
          },
          {
            title:'购买明细',
            href : '#/buyDetails',
            img : 'img/goumai.png'
          }

        ];

       
        
        
        //

        $scope.getLuckyData = [];
        //获取最近中奖消息
        function getLuckyData_1() {
           ActivityModel.getluckyInfo(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.getLuckyData = [];
                  $timeout(function() {
                    $scope.getLuckyData = re.data;
                  })
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取最近中奖消息失败：' + '状态码：' + response.status);
          },null)
        }

            function getHomeNewPublish() {
                ActivityModel.getHomeNewPublish(function(xhr, re) {
                    var code = re.code;
                    if (code == 0) {
                        $scope.newPublish = re.data;
                    } else {
                        ToastUtils.showMsgWithCode(code, re.msg);
                    }
                }, function(response, data) {
                    ToastUtils.showMsgWithCode(7, '获取最新揭晓失败：' + '状态码：' + response.status);
                })
            }
        
        function initConfig() {
          $scope.isLoadFinished = true;
          $scope.pageConfig = [{
            index:1,
            isLoading:false,
            data:[],
            goods_type_id:'',
            order_key:'weight',   //类别
            oder_type:'',
            activity_type:0,//1、非10元；2、10元；3、限购
            emptyData:false,
            page:0,
            pageOver:false,
            pageCount:20
          }]
          getLuckyData_1();
            // getHomeNewPublish();
	  $scope.getData(true)	
        }
        
        $scope.doRefresh = function(){
          initConfig()
        };
        $scope.changeActive = function(order_key,order_type,config) {
          if(!$scope.isLoadFinished) return;
          config.order_key = order_key;
          config.isLoading = true;
          if(order_type == 'none') {
            config.order_type = '';
          } else if(order_type == 'asc') {
            config.order_type = 'desc';
          } else {
            config.order_type = 'asc';
          }
          config.page = 0;
          config.data = [];
          $scope.getData(true);
          

        }
        $scope.getMoreData = function() {
          if($scope.pageConfig[0].isLoading) return;
          $scope.getData()
        }
        $scope.getData = function(doRefresh) {
            var postData = $scope.pageConfig[0];
            postData.isLoading = true;
            postData.page++
            ActivityModel.getActivityList(null,null,postData.order_key, postData.order_type,(postData.page - 1) * postData.pageCount + 1,postData.pageCount,'0',postData.activity_type, function(xhr, re) {
               var code = re.code;
               if (code == 0) {
                  var data = re.data;
                  var len = data.length;
                  for(var i = 0;i < len;i++) {
                    postData.data.push(data[i]);
                  }
                  if(len == postData.pageCount) {
                    postData.pageOver = false;
                  } else {
                    postData.pageOver = true;
                  }
                 
               } else {
                   ToastUtils.showMsgWithCode(code, re.msg);
               }
               
           }, function(response, data) {
               ToastUtils.showMsgWithCode(7, '获取商品列表失败：' + '状态码：' + response.status);
           }, function() {
              postData.isLoading = false;
              if(doRefresh) $scope.$broadcast('scroll.refreshComplete');
              $scope.$broadcast('scroll.infiniteScrollComplete');
           })
       }

       
       
        $scope.getPercentageProgress = function(remain_num,need_num){
          var progress = (need_num - remain_num) * 100 / need_num;
          if(progress > 0 && progress < 1) progress = 1;
          return Math.floor(progress);
        };

        function addToCart(broad){
          var shopItem = broad;
          shopItem.join_number = 1;
          trolleyInfo.addGoodsItem(shopItem);
        };

        $scope.addToCart = addToCart;

        $scope.goNext = function(){
          $state.go('tab.publish');
        };

       
         $scope.$on('$ionicView.beforeEnter', function(ev, data) {
            initConfig();
	           $timeout(function() {
              $ionicSlideBoxDelegate.next();
            },1000)
          })

        $scope.$on('$stateChangeStart', function() {
            //if($scope.getHomeNewPublishTimeOut) $timeout.cancel($scope.getHomeNewPublishTimeOut);
        });
        
    }]);
});

