/**
 * Created by songmars on 16/1/5.
 */

define(
  [ 'app',
    'models/model_app',
    'utils/toastUtil',
    'html/common/geturl_service'
  ],
  function (app) {
    app.controller('ShareOrderCtrl', ShowOrderCtrl);

    ShowOrderCtrl.$inject = ['$scope','$state','$stateParams','AppModel','ToastUtils','MyUrl','$ionicHistory'];
    function ShowOrderCtrl($scope,$state, $stateParams,AppModel,ToastUtils,MyUrl,$ionicHistory) {

      var uid = ($stateParams.uid == '所有') ?  null : $stateParams.uid;
      var goodsId = ($stateParams.goodsId == '所有')? null : $stateParams.goodsId ;
      var indexFrom = 1 ;//从第几条数据开始返回
      var perRequestNum = 10 ;//每次请求多少条数据
      var isDoRefreshing = false ;//是否正在做刷新操作
      $scope.isLoadFinished = false ;//首次加载是否结束
      $scope.pageTitle = $stateParams.pageTitle ;//页面标题
      
      if($scope.pageTitle == '我的晒单') {
        $scope.my = 1;
      } else {
        $scope.my = 0;
      }
      $scope.pageTitle = $scope.pageTitle || '所有晒单';
      writeTitle($scope.pageTitle);
      $scope.orderlist = [] ;
      ToastUtils.showLoading('加载中....');
      $scope.page = 0 ;
      $scope.type = 'time';
      $scope.hasMoreData = true ;

      getShareOrderData(true);

      /**
       * 刷新
       */
      $scope.doRefresh = function(){
        $scope.page = 0 ;
        $scope.hasMoreData = true ;
        isDoRefreshing = true ;
        getShareOrderData(isDoRefreshing);
      };

      /**
       * 加载更多
       */
      $scope.doLoadMore = function(){
        if(!isDoRefreshing){
          // indexFrom = $scope.orderlist.length + 1 ;
          getShareOrderData(false);
        }

      };

      /**
       * 数据是否为空
       * @returns {boolean}
       */
      $scope.isDataEmpty = function(){
        var isEmpty = true ;
        if($scope.orderlist.length>0){
          isEmpty = false ;
        }
        return isEmpty ;
      };

      var isConnect = true ;//网络是否连接
      /**
       * 显示断网页面
       * @returns {boolean}
       */
      $scope.isShowDisconnect = function(){
        return $scope.isDataEmpty() && $scope.isLoadFinished && !isConnect ;
      };

      /**
       * 跳转到首页夺宝
       */
      $scope.startToMainPage = function(){
        $state.go('tab.mainpage');
      };


      /**
       * 跳转到TA的页面
       * @param uicon
       * @param unick
       */
      $scope.goToHisPage = function(uicon,unick,uid){
        $state.go('hispage',{uicon:uicon,unick:unick,uid:uid});
      };

      // $scope.doRefresh();
      $scope.goToMyAccount=function(){
        $state.go('tab.account')


      };

      $scope.back = function() {
          $ionicHistory.goBack();
      }

      $scope.changeType = function(type) {
        
        if(!isDoRefreshing){
          $scope.type = type;
          $scope.page = 0 ;
          $scope.hasMoreData = true ;
          isDoRefreshing = true ;
          ToastUtils.showLoading('加载中....');
          getShareOrderData(true);
        }
      }

      /**
       * 获取晒单数据
       * @param isRefresh
       */
      function getShareOrderData(isRefresh){
        $scope.page++;
        AppModel.getShare_list(null,$scope.type,$scope.page,$scope.my,function(response){
          //onSuccess
          isConnect = true ;
          var code = response.data.code ;
          var msg = response.data.msg ;
          switch (code){
            case 0 :
              var dataList = response.data.data ;
              if(isRefresh){
                $scope.orderlist = [] ;
                isDoRefreshing = false ;
              }
              if(dataList.length>=10){
                $scope.hasMoreData = true ;
                // dataList.pop();
              }else{
                $scope.hasMoreData = false ;
              }
              $scope.orderlist = $scope.orderlist.concat(dataList);
              break;

            default :
              ToastUtils.showError(msg);
              break ;
          }
        },function(response){
          //onFail
          isConnect = false ;
          if(!$scope.isDataEmpty()){
            ToastUtils.showError('请检查网络状态，状态码：' + response.status);
          }
        },function(){
          //onFinal
          $scope.isLoadFinished = true ;
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          ToastUtils.hideLoading();
        });
      }

      $scope.zan = function(order) {
        try {
          if (!MyUrl.isLogin()) {
            event.preventDefault();
            $state.go('login',{'state':STATUS.LOGIN_ABNORMAL});
            ToastUtils.showWarning('请先登录！！');
            return;
          } else {
          }
        } catch (e) {
          console.error('登录判断跳转出错'+ e.name+'：'+ e.message);
        }
        if(order.is_zan) {
          ToastUtils.showSuccess('您已经赞过~');
          return;
        }
        AppModel.zan(order.show_id, function(xhr, re) {
            var code = re.code;
            if (code == 0) {
              order.zans = Number(order.zans) + 1;
              order.is_zan = true;
              ToastUtils.showSuccess('点赞成功');
            } else {
                ToastUtils.showMsgWithCode(code, re.msg);
            }
        }, function(response, data) {
            ToastUtils.showMsgWithCode(7, '点赞失败：' + '状态码：' + response.status);
        }, null)

      }

    }




  });


