/**
 * Created by songmars on 15/12/29.
 */
var PAY_TYPE_WEIXIN = 1;
var PAY_TYPE_ZHIFUBAO = 2;
var PAY_TYPE_YUE = 3;
define(
  [
    'app',
    'html/trolley/trolley_service',
    'components/view-trolley/view_trolley_list',
      'models/model_goods',
      'utils/toastUtil',
    'components/view-recomend/view_recomend_list',
    'models/model_activity',
    'html/common/storage',
      'models/model_user',
      'models/model_app',
      'models/model_address'
  ],
  function(app){
    'use strict';
    app.controller('DirectTrolleyCtrl',['$rootScope','$scope','$state','trolleyInfo','$ionicPopup','$location','ToastUtils','ActivityModel','$ionicHistory','Storage','$stateParams','GoodsModel','userModel','Global','AppModel','addressModel','$timeout',
      function($rootScope,$scope,$state,trolleyInfo,$ionicPopup,$location,ToastUtils,ActivityModel,$ionicHistory,Storage,$stateParams,GoodsModel,userModel,Global,AppModel,addressModel,$timeout){

          $scope.addressList = []; //收货地址列表
        $scope.goodsId = $stateParams.goodsId;
          $scope.startToAddressList = function() {
              $state.go('addressList');
          };
          $scope.needPay = false;
          $scope.momey = 0;
          $scope.pay = {};
          $scope.$on('$ionicView.beforeEnter',function(){
              getAccount();
              GoodsModel.getGoodsDetail2($scope.goodsId,onSuccess,onFailed);//for test
              getDefaultPayWay();
              getAddressList(); //获取收货地址
          });


          /**
           * 获取收货地址列表
           */
          function getAddressList() {
              addressModel.getAddressList(function(response) {
                  //onSuccess
                  var code = response.data.code;
                  var msg = response.data.msg;
                  switch (code) {
                      case 0:
                          $scope.addressList = response.data.data;
                          $scope.addressId = response.data.data[0]['address_id'];
                          break;
                      case 6:
                          ToastUtils.showWarning(msg);
                          $state.go('login');
                          break;
                      default:
                          ToastUtils.showError(msg);
                          break;
                  }
              }, function(response) {
                  //onFail
                  //ToastUtils.showError('请检查网络,状态码：' + response.status);
              });
          }


          function getAccount() {
              userModel.getAccount(function(xhr, re) {
                  if (re.code == 0) {
                      $scope.money = re.data.money;
                  } else {
                      ToastUtils.showError(re.msg);
                  }
              }, function(xhr, re) {
                  ToastUtils.showError(re.msg);
              }, function() {
                  ToastUtils.hideLoading();
              })
          }



        $scope.minusNumber = function(goods){
            if(goods.chooseNum > 1){
                goods.chooseNum--;
                goods.goodsPrice = parseInt(goods.chooseNum * $scope.goods.value);
                checkNeedPay();
            }
        }
        $scope.addNumber = function(goods){
            if(goods.chooseNum < $scope.goods.stock){
                goods.chooseNum++;
                goods.goodsPrice = parseInt(goods.chooseNum * $scope.goods.value);
                checkNeedPay();
            }
        }
        $scope.editJoinNumber = function(goods){
            var joinNumber = goods.chooseNum;
            var match = joinNumber.match(/^[0-9]*$/);
            if(match==null) {
                joinNumber = 1;
            }
            if(parseInt(joinNumber) > parseInt($scope.goods.stock)){
                joinNumber = $scope.goods.stock;
            }
            if(joinNumber < 1 && joinNumber!=''){
                joinNumber = 1;
            }
            goods.chooseNum = joinNumber;
            goods.goodsPrice = parseInt(goods.chooseNum * $scope.goods.value);
            checkNeedPay();
        }

        $scope.goToPay = function(goods){
            ToastUtils.showLoading('生成订单中');
            AppModel.getDirectOrder({"goodsId":$scope.goodsId,"num":$scope.goods.chooseNum,'payType':$scope.pay.type,'addressId':$scope.addressId},function(repose,data){
                if (data.code == 0) {
                    createOrderSuccess(data.data);
                } else {
                    ToastUtils.hideLoading();
                    ToastUtils.showError('生成订单失败: ' + data.msg);
                }
            },function() {
                ToastUtils.hideLoading();
                ToastUtils.showError('网络错误');
            });
        }

        function createOrderSuccess(data){
            if($scope.pay.type==PAY_TYPE_YUE){
                paySuccess(data.order_num);
            }else{
                getThirdPay(data.order_num,data.pay_url);
            }
        }

        function paySuccess(orderNum){
            ToastUtils.hideLoading();
            $state.go('direct-success',{
                'orderNum':orderNum
            });
        }

          function getThirdPay(orderNum, payUrl) {
              if (PAY_TYPE_WEIXIN == $scope.pay.type) { //微信支付下
                  if (Global.isInAPP()) {
                      ToastUtils.showLoading('正在调用支付服务，请稍候……');
                      AppModel.wx_app_pay(orderNum, function(xhr, re) {
                          var code = re.code;
                          if (code == 0) {
                              var data = re.data.param
                              var params = {
                                  "appId": data.appid,
                                  "partnerId": data.partnerid,
                                  "prepayId": data.prepayid,
                                  "packageValue": data.package,
                                  "nonceStr": data.noncestr,
                                  "timeStamp": data.timestamp,
                                  "sign": data.sign
                              };
                              dmwechat.wechatPay(params, function() {
                                  //支付成功
                                  paySuccess(orderNum);
                              }, function(err) {
                                  //支付失败
                                  ToastUtils.showMsgWithCode(7, '用户取消或支付失败');
                              })
                          } else {
                              ToastUtils.showMsgWithCode(code, re.msg);
                          }
                      }, function(response, data) {
                          ToastUtils.showMsgWithCode(7, '支付失败：' + '状态码：' + response.status);
                      }, function() {
                          ToastUtils.hideLoading();
                      })
                  } else {
                      OneWeChat.isWxEnable(function() {
                          var params = {
                              url: payUrl
                          };
                          OneWeChat.pay(params, function() {}, function() {

                          })
                      });
                  }

              } else if (PAY_TYPE_ZHIFUBAO == $scope.pay.type) { //支付宝下
                  if (Global.isInAPP()) {
                      ToastUtils.showLoading('正在调用支付服务，请稍候……');
                      AppModel.al_app_pay(orderNum, function(xhr, re) {
                          var code = re.code;
                          if (code == 0) {
                              dmwechat.aliPay(re.data.param, function() {
                                  //支付成功
                                  paySuccess(orderNum);
                              }, function(err) {
                                  //支付失败
                                  ToastUtils.showMsgWithCode(7, '用户取消或支付失败');
                              })
                          } else {
                              ToastUtils.showMsgWithCode(code, re.msg);
                          }
                      }, function(response, data) {
                          ToastUtils.showMsgWithCode(7, '支付失败：' + '状态码：' + response.status);
                      }, function() {
                          ToastUtils.hideLoading();
                      })
                  } else {
                      window.location.href = payUrl;
                  }
              }
          }

          function getDefaultPayWay() {
              if (Global.isInweixinBrowser()) {
                  $scope.hideWeixin = false;
                  $scope.hidezhifubao = true;
                  $scope.pay.type = PAY_TYPE_WEIXIN;
              } else if (Global.isInAPP()) {
                  $scope.hideWeixin = false;
                  $scope.hidezhifubao = false;
                  $scope.pay.type = PAY_TYPE_WEIXIN;
              } else {
                  $scope.hideWeixin = true;
                  $scope.hidezhifubao = false;
                  $scope.pay.type = PAY_TYPE_ZHIFUBAO;
              }
          }

          function validParams() {
              var isPayWayValid = $scope.pay.type == PAY_TYPE_WEIXIN || $scope.pay.type == PAY_TYPE_ZHIFUBAO || $scope.pay.type == PAY_TYPE_YUE;
              return $scope.goods.chooseNum >= 1 && isPayWayValid;
          }

        function checkNeedPay(){
            if(parseInt($scope.goods.goodsPrice) > parseInt($scope.money)){
                $scope.needPay = true;
            }else{
                $scope.needPay = false;
            }
        }

          function onSuccess(response, data) {
              if (data.code == 0) {
                  $scope.goods = data.data;
                  $scope.goods.chooseNum = 1;
                  $scope.goods.goodsPrice = data.data.value;
                  if($scope.goods.stock<1){
                      ToastUtils.showMsgWithCode(7, '商品库存不足');
                      $timeout(function(){
                          $ionicHistory.goBack();
                      },2000);
                  }else{
                      checkNeedPay();
                  }
              } else {
                  ToastUtils.showError(data.msg);
              }
          }

          function onFailed(response) {
              if (response.status !== 200) {
                  ToastUtils.showError('请检查网络');
              }
          }

    }])
  });

