/**
 * 获奖记录
 * Created by Administrator on 2016/1/7.
 */
define([
    'app',
    'models/model_user',
    'utils/toastUtil',
    'html/common/storage',
    'components/view-turnplate/view_turnplate',

], function(app) {

    app.controller(
        'turntableCtrl', ['$scope', '$ionicHistory', '$location', '$state', '$stateParams', '$timeout', 'userModel', 'ToastUtils', 'Storage', '$ionicPopup',
            function($scope, $ionicHistory, $location, $state, $stateParams, $timeout, userModel, ToastUtils, Storage, $ionicPopup) {
                var sessId = Storage.get("sessId");
                $scope.goBack = function() {
                    $ionicHistory.goBack();
                };

                getLottery();

                function getLottery() {
                    ToastUtils.showLoading('加载中....');
                    userModel.getLottery(function(xhr, re) {
                        var code = re.code;
                        if (code == 0) {
                            var data = re.data.data;

                            if(re.data.point) $scope.needPoint = re.data.point;
                            var restaraunts = [];
                            var iconImg = [];
                            if (data) {
                                $scope.lottery = data;

                                for (var i = 0, len = data.length; i < len; i++) {
                                    restaraunts.push(data[i].name);
                                    iconImg.push(data[i].img);
                                }
                                $scope.turnplate = {
                                    restaraunts: restaraunts, //大转盘奖品名称
                                    iconImg: iconImg
                                };
                            } else {
                                $scope.lottery = [];
                                $scope.turnplate = {
                                    restaraunts: restaraunts, //大转盘奖品名称
                                    iconImg: iconImg
                                };
                            }

                        } else {
                            ToastUtils.showMsgWithCode(code, re.msg);
                        }
                    }, function(response, data) {
                        ToastUtils.showMsgWithCode(7, '获取奖品列表失败：' + '状态码：' + response.status);
                    }, function() {
                        ToastUtils.hideLoading();
                    })
                }
                //监听抽奖启动信号
                $scope.$on('turnplate.startNow', function(scope, compId) {
                    if ('9-1-1' == compId) {
                        if($scope.lottery.length > 0 && ($scope.needPoint || $scope.needPoint == 0) ) {
                            $ionicPopup.confirm({
                                title: '<div>每次抽奖需要消耗' + $scope.needPoint + '积分</div><div>确定抽奖？（每天首次免费）</div>',
                                cancelText: '取消',
                                cancelType: 'button-default',
                                okText: '确定',
                                okType: 'button-assertive'
                            }).then(function(res) {
                                if (res) {
                                    //启动转盘
                                    getLotteryRun();
                                } else {

                                }
                            })
                        } else {
                            $ionicPopup.confirm({
                                title: '<b>抽奖活动尚未开始，敬请期待~</b>',
                                scope: $scope,
                                buttons: [{
                                    text: '确定',
                                    onTap: function(e) {
                                        return false;
                                    }
                                }]
                            });
                        }


                    }
                });

                function getLotteryRun() {
                    userModel.getLotteryRun(function(xhr, re) {
                        var code = re.code;
                        if (code == 0) {
                            var lotteryInfo = getLotteryInfo(re.data.id);
                            if (lotteryInfo) {
                                $scope.$broadcast('turnplate.start', '9-1-1', lotteryInfo.index, function() {
                                    if(lotteryInfo.name.indexOf('谢谢') > -1) {
                                      var alertPopup = $ionicPopup.alert({
                                           title: '抽奖结果',
                                           template: '没有中奖，不要气馁，再接再厉~',
                                           okText: '确定',
                                           okType: 'button-default'
                                         });
                                    } else {

                                        var alertPopup = $ionicPopup.alert({
                                           title: '抽奖结果',
                                           template: '恭喜您获得' +lotteryInfo.name,
                                           okText: '确定',
                                           okType: 'button-default'
                                        });
                                        $scope.doRefresh()
                                    }
                                    
                                });
                            } else {
                                //找不到指定奖品处理
                                ToastUtils.showMsgWithCode(7, '出现未知错误');
                            }


                        } else {
                            ToastUtils.showMsgWithCode(code, re.msg);
                        }
                    }, function(response, data) {
                        ToastUtils.showMsgWithCode(7, '抽奖出现错误：' + '状态码：' + response.status);
                    }, null)
                }

                function getLotteryInfo(id) {
                    var lottery = $scope.lottery;
                    for (var i = 0, len = lottery.length; i < len; i++) {
                        if (id == lottery[i].id) {
                            return {
                                index: i,
                                name: lottery[i].name,
                                id: id
                            }
                        }
                    }

                }

                $scope.lotteryListData = [];
                $scope.page = 0;
                $scope.isLoadFinished = true;
                getLotteryList();
                $scope.getLotteryList = getLotteryList;

                function getLotteryList(doRefresh) {
                    if (!$scope.isLoadFinished) return;
                    $scope.page++;
                    $scope.isLoadFinished = false;
                    userModel.getLotteryList($scope.page, function(xhr, re) {
                        var code = re.code;
                        if (code == 0) {
                            var data = re.data.id;
                            var len = data.length;
                            for (var i = 0; i < len; i++) {
                                $scope.lotteryListData.push(data[i]);
                            }
                            if (len < 10) {
                                $scope.moreDataCanBeLoaded = false;
                            } else {
                                $scope.moreDataCanBeLoaded = true;
                            }
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        } else {
                            ToastUtils.showMsgWithCode(code, re.msg);
                        }
                    }, function(response, data) {
                        ToastUtils.showMsgWithCode(7, '获取奖品列表失败：' + '状态码：' + response.status);
                    }, function() {
                        $scope.isLoadFinished = true;
                        if (doRefresh) $scope.$broadcast('scroll.refreshComplete');
                    })
                }
                
                $scope.doRefresh = function() {
                  $scope.page = 0;
                  $scope.isLoadFinished = true;
                  $scope.lotteryListData = [];
                  getLotteryList('doRefresh');
                }




            }
        ])

});
