/**
 * 获奖记录
 * Created by Administrator on 2016/1/7.
 */
define([
    'app',
    'models/model_invite',
    'models/model_app',
    'html/common/service_user_info',
    'components/view-list-item/view_list_item',
    'html/common/constants',
    'utils/toastUtil',
    'html/common/global_service',
    'html/thirdParty/thirdparty_wechat',
    'html/thirdParty/thirdparty_wechat_js',
    'html/common/storage',
    'models/model_goods'
], function(app) {

    app.controller(
        'WinningRecordCtrl', ['$scope', '$ionicHistory', '$location', '$state', '$stateParams', '$timeout', 'AppModel', 'userInfo', 'ToastUtils', 'weChatJs', 'WeChatShare', 'Global', 'GoodsModel', 'inviteModel','Storage',
            function($scope, $ionicHistory, $location, $state, $stateParams, $timeout, AppModel, userInfo, ToastUtils, weChatJs, WeChatShare, Global, GoodsModel, inviteModel,Storage) {
                if (Global.isInweixinBrowser()) {
                    weChatJs.wxConfigInit(onInitSuccess, onInitFailed);
                }
                var _recordView = document.getElementById('congratulation');

                setTimeout(getRebateInfo, 500);
                if(Storage.get('winning_record_status')) {
                    Storage.remove('winning_record_status');
                    initChoujiang();
                } else {
                    initDuobao();
                }


                function initDuobao() {
                    $scope.type = 'duobao';
                    $scope.requestUrl = AppModel.getWinRecordListUrl();
                    $scope.isShowShare = false;
                    $scope.requestParams = {
                        uid: null,
                        logistics_stat: null,
                        status: null
                    };

                    $scope.callBack = {
                        setData: function setData(data) {
                            $scope.recordList = data;
                            var unrecord;
                            for (var i = 0; i < data.length; i++) {
                                unrecord = data[i];
                                if (0 == unrecord.status) {
                                    $scope.unreadRecords.push(unrecord);
                                }
                            }
                            showUnreadRecord();
                        }

                    };

                }

                function initChoujiang() {
                    $scope.type = 'zhuanpan';
                    $scope.requestUrl = '?c=nc_user&a=lotteryList2';
                    $scope.isShowShare = false;
                    $scope.requestParams = {};
                    $scope.callBack = {
                        setData: function setData(data) {
                            $scope.zhuanpanRecordList = data;

                        }

                    };
                }
                $scope.unreadRecords = [];
                $scope.changeType = function(type) {
                        if (type == 'duobao') {
                            initDuobao()
                        } else {
                            initChoujiang()
                        }
                        $timeout(function() {
                            $scope.$broadcast('view_list_view.refresh', '9-1-1')
                        })

                    }
                   
                    /**
                     *
                     * 获取邀请返利信息
                     */
                function getRebateInfo() {
                    inviteModel.getRebateInfo(function(response) {
                        //onSuccess
                        var code = response.data.code;
                        var msg = response.data.msg;
                        switch (code) {
                            case 0:
                                var data = response.data.data;
                                var invite_code = data.invite_code;
                                mLink = baseUrl + '#/boostrap/' + invite_code;
                                break;
                            default:
                                ToastUtils.showError(msg);
                                break;

                        }
                    }, function(response) {
                        //onFail
                        ToastUtils.showError('请检查网络状态，状态码：' + response.status);
                    });
                }


                function showWinDialog() {
                    _recordView.className = _recordView.className + ' show';
                }

                function hideWinDialog() {
                    _recordView.className = _recordView.className.replace('show', '');
                }

                function showUnreadRecord() {
                    if ($scope.unreadRecords.length > 0) {
                        $timeout(function() {
                            $scope.unreadRecord = $scope.unreadRecords.pop();
                            showWinDialog();
                        }, 300);
                    }
                };

                $scope.closeUnreadRecord = function() {
                    hideWinDialog();
                    showUnreadRecord();
                };
                var mTitle = appConfig.shareTitle || '一元就能买iPhone。我已经中奖啦，快来试试吧！';
                var mImgUrls = baseUrl + 'img/share_icon.jpg';
                var mLink = baseUrl + '#/boostrap/';
                var mContent = '一元就能买iPhone。最刺激的商城玩法！';

                $scope.doShareRecord = function(record) {
                    //ToastUtils.showNormal('分享启动中……');
                    //console.info('分享启动中……'+JSON.stringify(record));
                    mTitle = '一元就能买'+ record.goods_title + '。我已经中奖啦，快来试试吧！'  ;
                    mContent = '一元就能买'+ record.goods_title + '。最刺激的商城玩法！';
                    if(record.goods_img) mImgUrls = record.goods_img;
                    if (Global.isInweixinBrowser()) {
                        showGuide();
                        hideWinDialog();
                        weChatJs.wxShareToTimeline(mTitle, mLink, mImgUrls, onShareSuccess, onShareCancel);
                        weChatJs.wxShareToAppMessage(mTitle,mContent,mLink, mImgUrls, onShareSuccess, onShareCancel)
                        //ToastUtils.showShortNow(STATE_STYLE.GOOD, '请打开右上角分享');
                        //显示引导分享界面
                    } else if (Global.isInAPP()) {
                        $scope.isShowShare = true;

                    }
                };
                //app分享到朋友圈
                $scope.shareToFriendsCircle = function() {
                    // var shareScene = WeChatShare.WechatShareScene.TIMELINE;
                    if (Global.isInAPP()) {
                        //app分享
                        var data = {
                            "title": mTitle,
                            "content": mContent,
                            "imgUrl": mImgUrls,
                            "targetUrl": mLink
                        }
                        dmwechat.share('wx_circle', data, function() {
                                ToastUtils.showShortNow(STATE_STYLE.GOOD, '炫耀成功');
                                $scope.isShowShare = false;
                            }, function(error) {
                                ToastUtils.showShortNow(STATE_STYLE.ERROR, error);
                            })

                    }

                };

                //app分享给好友
                $scope.shareToFriends = function() {
                    if (Global.isInAPP()) {
                        var data = {
                            "title": mTitle,
                            "content": mContent,
                            "imgUrl": mImgUrls,
                            "targetUrl": mLink
                        }
                        dmwechat.share('wx', data, function() {
                            ToastUtils.showShortNow(STATE_STYLE.GOOD, '炫耀成功');
                            $scope.isShowShare = false;
                        }, function(error) {
                            ToastUtils.showShortNow(STATE_STYLE.ERROR, error);
                        })

                    }

                };
                $scope.hidePop = function() {
                    $scope.isShowShare = false;
                };
                $scope.parseLogisticsStat = function(logistics_stat) {
                    var state = '';
                    if (0 == logistics_stat) {
                        state = '等待发货';
                    } else if (1 == logistics_stat) {
                        state = '已发货';
                    } else if (2 == logistics_stat) {
                        state = '已签收';
                    }
                    return state;
                };

                $scope.getMyActivityNum = function(activityId) {
                    $scope.hideMyActivityNum();
                    AppModel.getActivityNum(activityId, null, function(response, data) {
                        var code = data.code;
                        if (0 == code) {
                            $scope.activityNums = data.data;
                        } else {
                            ToastUtils.showError('获取失败：' + data.msg);
                        }
                    }, function(response) {
                        ToastUtils.showError('获取夺宝号失败：' + '状态码：' + response.status);
                    });
                };

                $scope.hideMyActivityNum = function() {
                    $scope.activityNums = undefined;
                };

                $scope.startToCheckReceive = function(record, type) {
                    ToastUtils.showLoading('正在签收.....');
                    if (type == 'duobao') {
                        GoodsModel.checkReceive(record.activity_id, function(response, data) {
                            var code = data.code;
                            if (0 == code) {
                                record.logistics_stat = 2;
                                ToastUtils.showSuccess('成功签收');
                            } else {
                                ToastUtils.showError('签收失败：' + data.msg);
                            }
                        }, function(response) {
                            ToastUtils.showError('网络异常：' + response.statusText);
                        }, function() {
                            ToastUtils.hideLoading();
                        });
                    } else {
                        GoodsModel.checkReceiveChoujiang(record.id, function(response, data) {
                            var code = data.code;
                            if (0 == code) {
                                record.send = 2;
                                ToastUtils.showSuccess('成功签收');
                            } else {
                                ToastUtils.showError('签收失败：' + data.msg);
                            }
                        }, function(response) {
                            ToastUtils.showError('网络异常：' + response.statusText);
                        }, function() {
                            ToastUtils.hideLoading();
                        });
                    }

                };

                $scope.startToMyShareOrder = function(activity_id, address) {
                    $state.go('editShareOrder', {
                        'activity_id': activity_id,
                        'address': address
                    })
                };

                $scope.goToBuy = function() {
                    // $location.path('/tab/mainpage').replace();
                    $state.go('tab.mainpage');
                };
                $scope.goToTurntable = function() {
                    // $location.path('/tab/mainpage').replace();
                    $state.go('turntable');
                };

                $scope.hideGuide1 = function() {
                    hideGuide();
                }

                /**
                 * 跳转到选择地址页面
                 * @param activityId
                 */
                $scope.startToAddressSelect = function(activityId, type) {
                    if(type == 'choujiang') {
                        Storage.set('winning_record_status',true)
                    } else {
                        Storage.remove('winning_record_status')
                    }
                    $state.go('addressSelect', { activity_id: activityId, type: type });
                };

                var activity_id = $stateParams.activity_id;
                var address = $stateParams.address;
                $scope.goBack = function() {
                    // $location.path('/tab/account').replace();
                    $state.go('tab.account');
                };

                function initial() {
                    setTimeout(function() {
                        $scope.$broadcast('view_list_view.refresh', '9-1-1');
                    }, 300);
                }

                initial();

                function showGuide() {
                    document.getElementById("guidepop").style.display = 'block';

                }

                function hideGuide() {
                    document.getElementById("guidepop").style.display = 'none';

                }

                function onShareSuccess() {
                    hideGuide();
                    ToastUtils.showShortNow(STATE_STYLE.GOOD, '微信分享成功');
                }

                function onShareCancel() {
                    hideGuide();
                    ToastUtils.showShortNow(STATE_STYLE.ERROR, '用户已取消分享');

                }

                function onInitSuccess() {


                    // ToastUtils.showShortNow(STATE_STYLE.GOOD, 'wxconfig初始化成功');

                }

                function onInitFailed() {

                    ToastUtils.showShortNow(STATE_STYLE.ERROR, 'wxconfig初始化失败');

                }




            }
        ])

});
