define([
    'app',
    'models/model_user',
    'utils/toastUtil'
], function(app) {

    app.controller(
        'applyWithdrawCashCtrl', ['$scope', '$ionicHistory', '$location', '$state', '$stateParams', '$timeout', 'userModel', 'ToastUtils', '$state',
            function($scope, $ionicHistory, $location, $state, $stateParams, $timeout, userModel, ToastUtils, $state) {
                $scope.cash = {
                    wechatId: null,
                    money: null
                };
                $scope.inviteMoney = sessionStorage.getItem('inviteMoney');

                function validate() {
                    var msg = "false";
                    var money = Number($scope.cash.money) || 0;
                    if ($scope.cash.wechatId === '') {
                        msg = "微信号不能为空";
                    } else if (money == 0) {
                        msg = "提现金额不能为空";
                    } else if (money > $scope.inviteMoney) {
                        msg = "提现金额不能大于当前佣金";
                    } else {
                        msg = "true";
                    }

                    return msg;
                }

                $scope.submit = function() {
                    var validateMsg = validate();
                    if (validateMsg !== 'true') {
                        ToastUtils.showTips(validateMsg);
                        return;
                    }
                    var postData = {
                        weixin_id: $scope.cash.wechatId,
                        money: $scope.cash.money
                    };
                    userModel.getApplyCash(postData, function(xhr, re) {
                        var code = re.code;
                        if (code == 0) {
                            ToastUtils.showSuccess('申请提现成功');
                            $state.go('inviteFriends');
                        } else {
                            ToastUtils.showMsgWithCode(code, re.msg);
                        }
                    }, function(response, data) {
                        ToastUtils.showMsgWithCode(7, '申请提现失败：' + '状态码：' + response.status);
                    }, function() {
                        $scope.isLoadFinished = true;
                        if (doRefresh) $scope.$broadcast('scroll.refreshComplete');
                    });
                };

                $scope.goBack = function() {
                    $ionicHistory.goBack();
                };

            }
        ])

});
