/**
 * Created by suiman on 16/1/5.
 */

define(
  [
    'app',
    'utils/httpRequest'
  ],
  function (app) {
    app.factory('GoodsModel', goodsModel);
    goodsModel.$inject = ['httpRequest'];

    function goodsModel(httpRequest) {
        return {
          getGoodsDetail: getGoodsDetail,       //宝贝详情
          getGoodsDetail2: getGoodsDetail2,       //宝贝详情
          getGoodsImgDetail:getGoodsImgDetail,  //图文详情
          getJoinRecordList:getJoinRecordList,  //参与记录
          getHistoryList: getHistoryList,       //往期揭晓
          getShowOrderList:getShowOrderList,    //晒单分享
          editShowOrderList:editShowOrderList,  //发表晒单
          publishImg:publishImg,                //上传图片
          getCountDetail: getCountDetail,       //计算详情
          checkReceive:checkReceive,            //签收

          getHistoryUrl : getHistoryUrl,        //获取往期揭晓URL
          getJoinRecordUrl: getJoinRecordUrl,  //获取参与记录URL
          getShowOrderUrl: getShowOrderUrl,      //获取晒单分享URL
          checkReceiveChoujiang:checkReceiveChoujiang,
          checkReceiveDirect:checkReceiveDirect,
          getExpress:getExpress,
          getExpress2:getExpress2,
          buyDetails:buyDetails
        };


         function buyDetails(num_id, onSuccess, onFailed, onFinal) {
          var url = '?c=nc_user&a=allJoin';
          var params = {
            num_id: num_id
          };
          return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
        }


      /**
       *
       * @param {Number}activityId  期号
       * @param onSuccess
       * @param onFailed
       * @param onFinal
       * @returns {*|Object}
       */
        function getGoodsDetail(activityId, onSuccess, onFailed, onFinal) {
          var url = '?c=nc_goods&a=detail';
          var params = {
            activity_id: activityId
          };
          return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
        }

      function getGoodsDetail2(goodsId, onSuccess, onFailed, onFinal) {
        var url = '?c=nc_goods&a=detail2';
        var params = {
          goodsId: goodsId
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      /**
       *
       * @param {Number}goodsId 商品id
       * @param onSuccess
       * @param onFailed
       * @param onFinal
       * @returns {*|Object}
       */
        function getGoodsImgDetail(goodsId, onSuccess, onFailed, onFinal) {
          var url = '?c=nc_goods&a=img_detail';
          var params = {
            goods_id: goodsId
          };
          return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
        }

      /**
       *
       * @param {Number}activityId  期号
       * @param {Number}from        表示从第几条开始返回数据，默认:1，表示从第1条开始
       * @param {Number}count       表示最多拉取几条消息过来，默认:10
       * @param onSuccess
       * @param onFailed
       * @returns {*|Object}
       */
        function getJoinRecordList(activityId, from, count, onSuccess, onFailed,onFinal) {
          //var url = '?c=nc_goods&a=join_record_list';
          var url = '?c=nc_goods&a=join_list&';
          var params = {
            activity_id: activityId,
            from:from,
            count:count
          };
          return httpRequest.post(url, params, onSuccess, onFailed,onFinal);
        }

      function getJoinRecordUrl() {
        return '?c=nc_goods&a=join_list&';
      }

      /**
       *
       * @param {Number}goodsId 商品id
       * @param {Number}from    表示从第几条开始返回数据，默认:1，表示从第1条开始
       * @param {Number}count   表示最多拉取几条消息过来，默认:10
       * @param onSuccess
       * @param onFailed
       * @param onFinal
       * @returns {*|Object}
       */
        function getHistoryList(goodsId, from, count, onSuccess, onFailed,onFinal) {
          var url = '?c=nc_goods&a=history_list';
          var params = {
            goods_id: goodsId,
            from:from,
            count:count
          };

          return httpRequest.post(url, params, onSuccess, onFailed,onFinal);
        }

        function getHistoryUrl(){
          return '?c=nc_goods&a=history_list';
        }


       /**
       *
       * @param {Number}goodsId 商品id
       * @param {Number}uid     过滤
       * @param {Number}from    表示从第几条开始返回数据，默认:1，表示从第1条开始
       * @param {Number}count   表示最多拉取几条消息过来，默认:10
       * @param onSuccess
       * @param onFailed
       * @returns {*|Object}
       */
        function getShowOrderList(goodsId,uid, from, count, onSuccess, onFailed) {
          var url = '?c=nc_user_show&a=share_list';
          var params = {
            goods_id: goodsId,
            uid:uid,
            from:from,
            count:count
          };
          return httpRequest.post(url, params, onSuccess, onFailed,null);
        }

      function getShowOrderUrl() {
        return '?c=nc_user_show&a=share_list';
      }



       function editShowOrderList(activityId,directId,show_title,show_desc,img,onSuccess,onFailed){
         var url='?c=nc_user_show&a=do_share';
         var params={
           activity_id:activityId,
           direct_id:directId,
           show_title:show_title,
           show_desc:show_desc,
           img:img
         };

         return httpRequest.post(url, params, onSuccess, onFailed);

       }

      function publishImg(file,onUpLoadSuccess,onUpLoadFail){

        var params={
          file:file
        };
        httpRequest.post('?c=bbs&a=upload_img_base64&',params,onUpLoadSuccess,
          onUpLoadFail);

      }

      function getCountDetail(activityId, onSuccess, onFailed, onFinal) {
        var url = '?c=nc_goods&a=lucky_num_detail';
        var params = {
          activity_id: activityId
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      function checkReceive(activityId, onSuccess, onFailed, onFinal){
        var url = '?c=nc_user&a=check_receive';
        var params = {
          activity_id: activityId
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      function checkReceiveChoujiang(id, onSuccess, onFailed, onFinal){
        var url = '?c=nc_user&a=check_receive2';
        var params = {
          id: id
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      function checkReceiveDirect(id, onSuccess, onFailed, onFinal){
        var url = '?c=nc_user&a=check_receive3';
        var params = {
          id: id
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      //查询夺宝物流
      function getExpress(id, onSuccess, onFailed, onFinal){
        var url = '?c=nc_user&a=kuaidi';
        var params = {
          id: id
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }

      //查询抽奖物流
      function getExpress2(id, onSuccess, onFailed, onFinal){
        var url = '?c=nc_user&a=kuaidi2';
        var params = {
          id: id
        };
        return httpRequest.post(url, params, onSuccess, onFailed, onFinal);
      }


      }
  });
